//+------------------------------------------------------------------+
//|                                                 BDSwingEU_H1.mq4 |
//|                                    Copyright  2008, BlueDreamFX |
//|                              http://www.BlueDreamFX.Blogspot.Com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, BlueDreamFx"
#property link      "http://www.BlueDreamFX.Blogspot.Com"

#property indicator_chart_window

//************ Vol & HILO ********************
extern bool ShowHighLowLevel=true;
extern int PeriodCount=5;
extern string strPeriod="Daily=1440; Weekly=10080; Monthly=;43200";
extern int UsePeriod=PERIOD_D1;

extern int HorizontalTextPosition=100;
//extern color clrText=C'183,183,0';
//extern color clrHilo=C'98,98,0';
//extern color clrVolume=C'0,108,0';
extern color clrText=Gold;
extern color clrHilo=Blue;
extern color clrVolume=Green;
extern color clrPrice=Silver;

double Range;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicators
   if (UsePeriod<Period()||ShowHighLowLevel==false) DeleteHighLowLevel();
   else CreateHighLowLevel();

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   DeleteHighLowLevel();
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (UsePeriod<Period()||ShowHighLowLevel==false) DeleteHighLowLevel();
   else PossibleHighLowLevel();
   return(0);
  }
//+------------------------------------------------------------------+

void CreateHighLowLevel()
{
   ObjectCreate("h01",OBJ_HLINE,0,0,FurtherMovementHigh());   
   ObjectCreate("h02",OBJ_HLINE,0,0,FurtherMovementLow());   

   ObjectCreate("h03",OBJ_HLINE,0,0,NewHighPotential());   
   ObjectCreate("h04",OBJ_HLINE,0,0,NewLowPotential());   

//   ObjectCreate("h05",OBJ_HLINE,0,0,Close[0]);   

   ObjectSet("h01",OBJPROP_COLOR,clrVolume);
   ObjectSet("h02",OBJPROP_COLOR,clrVolume);
   ObjectSet("h03",OBJPROP_COLOR,clrHilo);
   ObjectSet("h04",OBJPROP_COLOR,clrHilo);
//   ObjectSet("h05",OBJPROP_COLOR,clrPrice);

   ObjectSet("h01",OBJPROP_BACK,true);
   ObjectSet("h02",OBJPROP_BACK,true);
   ObjectSet("h03",OBJPROP_BACK,true);
   ObjectSet("h04",OBJPROP_BACK,true);
//   ObjectSet("h05",OBJPROP_BACK,true);

   ObjectSet("h01",OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("h02",OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("h03",OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("h04",OBJPROP_STYLE,STYLE_DOT);
//   ObjectSet("h05",OBJPROP_STYLE,STYLE_DOT);

   ObjectCreate("t01",OBJ_TEXT,0,iTime(Symbol(),Period(),HorizontalTextPosition),NewHighPotential());   
   ObjectCreate("t02",OBJ_TEXT,0,iTime(Symbol(),Period(),HorizontalTextPosition),NewLowPotential());   
   ObjectCreate("t03",OBJ_TEXT,0,iTime(Symbol(),Period(),HorizontalTextPosition),Close[0]);   

}

void DeleteHighLowLevel()
{
   ObjectDelete("h01");
   ObjectDelete("h02");
   ObjectDelete("h03");
   ObjectDelete("h04");
//   ObjectDelete("h05");
   ObjectDelete("t01");
   ObjectDelete("t02");
   ObjectDelete("t03");
}

void PossibleHighLowLevel()
{
   ObjectMove("h01",0,iTime(Symbol(),Period(),HorizontalTextPosition),FurtherMovementHigh());
   ObjectMove("h02",0,iTime(Symbol(),Period(),HorizontalTextPosition),FurtherMovementLow());
   ObjectMove("h03",0,iTime(Symbol(),Period(),HorizontalTextPosition),NewHighPotential());
   ObjectMove("h04",0,iTime(Symbol(),Period(),HorizontalTextPosition),NewLowPotential());
//   ObjectMove("h05",0,iTime(Symbol(),Period(),HorizontalTextPosition),Close[0]);

   ObjectMove("t01",0,iTime(Symbol(),Period(),HorizontalTextPosition),NewHighPotential());
   ObjectMove("t02",0,iTime(Symbol(),Period(),HorizontalTextPosition),NewLowPotential());
   ObjectMove("t03",0,iTime(Symbol(),Period(),HorizontalTextPosition),Close[0]);
/*
   ObjectSetText("t01",VolumeComment(VolumeBalanceToUp())+" "+PipsToGoNewHigh()+" pips to go ("+DoubleToStr(PipsToGoNewHighPercent(),2)+"% To Complete)",8,"Arial",clrText);
   ObjectSetText("t02",VolumeComment(VolumeBalanceToDown())+" "+PipsToGoNewLow()+" pips to go ("+DoubleToStr(PipsToGoNewLowPercent(),2)+"% To Complete)",8,"Arial",clrText);
   ObjectSetText("t03","Bal:["+DoubleToStr(VolumeLeftPercent(),2)+"%Vol] ["+DoubleToStr(HILOLeftPercent(),2)+"%HILO, "+DoubleToStr(HILOLeft(),0)+" pips] "+Expectation(),8,"Arial",clrText);
*/
   ObjectSetText("t01","H : "+VolumeComment(VolumeBalanceToUp())+" "+PipsToGoNewHigh()+" pips to go",8,"Arial",clrText);
   ObjectSetText("t02","L : "+VolumeComment(VolumeBalanceToDown())+" "+PipsToGoNewLow()+" pips to go",8,"Arial",clrText);
   ObjectSetText("t03","["+DoubleToStr(VolumeLeftPercent(),2)+"%Vol Remain] ["+DoubleToStr(HILOLeftPercent(),2)+"%HILO Remain, "+DoubleToStr(HILOLeft(),0)+" pips]",8,"Arial",clrText);

}

double ConvertPipsToPoint(int Pips)
{
   return (Pips * Point);   
}

int ConvertPointToPips(double cPoint)
{
   if (cPoint<0) cPoint=cPoint*(-1);
   
   return (cPoint/Point);   
}

double PeriodVolume(int shift)
{
   return(iVolume(NULL,UsePeriod,shift));
}

double AverageVolume()
{
   double VolSum;
   int i;
   
   VolSum=0;
   for(i=1;i<=PeriodCount;i++)
   {
      VolSum+=iVolume(NULL,UsePeriod,i);
   }
   return(VolSum/PeriodCount);
}

double HILO(int shift)
{
   return(ConvertPointToPips(iHigh(NULL,UsePeriod,shift) -iLow(NULL,UsePeriod,shift)));
}

double AverageHILO()
{
   double Range;

   int i;
   
   Range=0;
   for(i=1;i<=PeriodCount;i++)
   {
      Range+=ConvertPointToPips((iHigh(NULL,UsePeriod,i) -iLow(NULL,UsePeriod,i)));
   }
      
   return(Range/PeriodCount);
      
}

//.................................................................
double VolumeLeft()
{
   return(AverageVolume()-PeriodVolume(0));
}

double VolumeLeftPercent()
{
   return(100*VolumeLeft()/AverageVolume());
}

double VolumeNeededToUp()
{
   return(PipsToGoNewHigh()*PeriodVolume(0)/HILO(0));
}

double VolumeNeededToDown()
{
   return(PipsToGoNewLow()*PeriodVolume(0)/HILO(0));
}

double VolumeBalanceToUp()
{
   return(VolumeLeft()-VolumeNeededToUp());
}

double VolumeBalanceToDown()
{
   return(VolumeLeft()-VolumeNeededToDown());
}

string VolumeComment(double Val)
{
   if(AverageHILO()<HILO(0)) return ("[Average Completed]");
   else if(Val<0) return (StringConcatenate("[ Insufficent ",DoubleToStr(-1*Val,0)," vol ]" )); 
   else return ("[Expected Sufficent Volume]");  
}

double HILOLeft()
{
//   if(AverageHILO()<HILO(0)) return(0);
   return(AverageHILO()-HILO(0));
}

double HILOLeftPercent()
{
   return(100*HILOLeft()/AverageHILO());
}

double NewHighPotential()
{
   return(iHigh(Symbol(),UsePeriod,0)+ConvertPipsToPoint(HILOLeft()));
}

int PipsToGoNewHigh()
{
   return(ConvertPointToPips(NewHighPotential()-Close[0]));
}

double NewLowPotential()
{
   return(iLow(Symbol(),UsePeriod,0)-ConvertPipsToPoint(HILOLeft()));
}

int PipsToGoNewLow()
{
   return(ConvertPointToPips(Close[0]-NewLowPotential()));
}


int FurtherMovementPips()
{
   return(VolumeLeft()*HILO(0)/PeriodVolume(0));  
}

double FurtherMovementHigh()
{
   return(Close[0]+ConvertPipsToPoint(FurtherMovementPips()));
}

double FurtherMovementLow()
{
   return(Close[0]-ConvertPipsToPoint(FurtherMovementPips()));
}

//.................................................................


