//+------------------------------------------------------------------+
//|                                           Bosun_Kines_Weekly.mq4 |
//|                         Copyright  2010, kris.pivo[at]gmail.com |
//+------------------------------------------------------------------+
#property copyright " Kris  2010 "                                //|
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 C'000,200,000' // SeaGreen
#property indicator_color2 C'000,200,000' // Green
#property indicator_color3 C'000,200,000' // Lime
#property indicator_color4 C'150,150,150' // Silver
#property indicator_color5 C'200,000,000' // Red
#property indicator_color6 C'200,000,000' // Crimson
#property indicator_color7 C'200,000,000' // Maroon
//---- input parameters
extern int MaxPeriod = 240;  //Chart period cannot be higher than Daily
extern int StartDay  = 0;     // 0=Sunday, 1=Monday
extern int FontSize  = 8;     // Pivot label font size
//---- buffers
double BufferR3[];
double BufferR2[];
double BufferR1[];
double BufferPP[];
double BufferS1[];
double BufferS2[];
double BufferS3[];

double WH,WL,WC,PP,PD,PRH,PRL;
double S1,R1,S2,R2,S3,R3;
double last_week_high, last_week_low, last_week_close, this_week_open;
//+------------------------------------------------------------------+

int deinit() {
   ObjectDelete("PivR3");
   ObjectDelete("PivR2");
   ObjectDelete("PivR1");
   ObjectDelete("PivPP");
   ObjectDelete("PivS1");
   ObjectDelete("PivS2");
   ObjectDelete("PivS3");
   
	ObjectDelete("LabPivR3");
	ObjectDelete("LabPivR2");
	ObjectDelete("LabPivR1");
	ObjectDelete("LabPivPP");
	ObjectDelete("LabPivS1");
	ObjectDelete("LabPivS2");
	ObjectDelete("LabPivS3");
	
	Comment("");
	return(0); }
//+------------------------------------------------------------------+

int init()
  {
   string short_name;

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,160);
   SetIndexBuffer(0,BufferR3);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,160);
   SetIndexBuffer(1,BufferR2);
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,160);
   SetIndexBuffer(2,BufferR1);
      
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,167);
   SetIndexBuffer(3,BufferPP);
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,160);
   SetIndexBuffer(4,BufferS1);
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,160);
   SetIndexBuffer(5,BufferS2);
   
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,160);
   SetIndexBuffer(6,BufferS3);
   
   short_name="Bosun Kines Weekly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexDrawBegin(0,1);
   return(0);  }

int start()
  {
   if (Period() > MaxPeriod) return(0);
   int counted_bars=IndicatorCounted();
   int limit, i;
   if (counted_bars==0)
     {
      ObjectCreate("PivR3", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivR3", "        R3",FontSize,"Arial",indicator_color1);
      ObjectCreate("PivR2", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivR2", "        R2",FontSize,"Arial",indicator_color2);
      ObjectCreate("PivR1", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivR1", "        R1",FontSize,"Arial",indicator_color3);
      ObjectCreate("PivPP", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivPP", "            Bosun",FontSize,"Arial",indicator_color4);
      ObjectCreate("PivS1", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivS1", "        S1",FontSize,"Arial",indicator_color5);
      ObjectCreate("PivS2", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivS2", "        S2",FontSize,"Arial",indicator_color6);
      ObjectCreate("PivS3", OBJ_TEXT, 0,0,0);
      ObjectSetText("PivS3", "        S3",FontSize,"Arial",indicator_color7);
     }
   if(counted_bars<0) return(-1);
//----
   limit=(Bars-counted_bars)-1;
//----
   for(i=limit; i>=0;i--)
     {
      if(StartDay==TimeDayOfWeek(Time[i]) && StartDay!=TimeDayOfWeek(Time[i+1]) )  
        {
         last_week_close=Close[i+1];
         this_week_open=Open[i];
         
         WH = last_week_high;
         WL = last_week_low;
         WC = last_week_close;

			R3 = WC * 1.0625;
			R2 = WC * 1.0312;         
			R1 = WC * 1.0156;
			PP = WC;
         S1 = WC * 0.9844;
			S2 = WC * 0.9688;
			S3 = WC * 0.9375;
			
         last_week_low  = Low[i];
         last_week_high = High[i];
//----
         ObjectMove("PivR3", 0, Time[i],R3);
         ObjectMove("PivR2", 0, Time[i],R2);
         ObjectMove("PivR1", 0, Time[i],R1);
         ObjectMove("PivPP", 0, Time[i],PP);
         ObjectMove("PivS1", 0, Time[i],S1);
         ObjectMove("PivS2", 0, Time[i],S2);
         ObjectMove("PivS3", 0, Time[i],S3);
        }
      last_week_high=MathMax(last_week_high, High[i]);
      last_week_low=MathMin(last_week_low, Low[i]);
      
      BufferR3[i]=R3;
      BufferR2[i]=R2;
      BufferR1[i]=R1;
      BufferPP[i]=PP;
      BufferS1[i]=S1;
      BufferS2[i]=S2;
      BufferS3[i]=S3;

   DoLabel( "LabPivR3", BufferR3[0], indicator_color1 );
   DoLabel( "LabPivR2", BufferR2[0], indicator_color2 );
   DoLabel( "LabPivR1", BufferR1[0], indicator_color3 );
   DoLabel( "LabPivPP", BufferPP[0], indicator_color4 );
   DoLabel( "LabPivS1", BufferS1[0], indicator_color5 );
   DoLabel( "LabPivS2", BufferS2[0], indicator_color6 );
   DoLabel( "LabPivS3", BufferS3[0], indicator_color7 );
	}
	return(0); }
	
void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }      
//+-----------------------------------------------------------------------------------------+
//|                                         THE END                                         |
//+-----------------------------------------------------------------------------------------+