//+------------------------------------------------------------------+
//|                                             Brian Inside Bar.mq4 |
//|                                  Copyright  2009, Gary Surowiec |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Gary Surowiec"
#property link      ""
#property indicator_chart_window

extern color LineColorLower=Red;
extern color LineColorHigher=Yellow;
//---- indicator parameters

datetime PrevBar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
    PrevBar = Time[0]; 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("OpenPrice");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   if (NewBar(PrevBar))
   {  
     PrevBar = Time[0]; 
     ObjectDelete("OpenPrice");
     ObjectCreate("OpenPrice", OBJ_TREND,0, Time[0],Open[0],Time[0]+(TFSec(Period())*5),Open[0]);
     if (Open[0] >= Open[1]) ObjectSet("OpenPrice", OBJPROP_COLOR,LineColorHigher); 
       else ObjectSet("OpenPrice", OBJPROP_COLOR,LineColorLower);
     if (High[1] < High[2] &&  Low[1] > Low[2]) 
     {
         SendMail("Inside Bar " + Symbol()+ "," + TF2Str(Period()) ,"Inside bar found " + Symbol() + "," + TF2Str(Period()) + " at " + TimeToStr(Time[1]));
         
         
     }
   }      
//----
   return(0);
  }
//+------------------------------------------------------------------+
 //+-------------------------------------------------------------------------+
//|                         New Bar                                         +   
//+-------------------------------------------------------------------------+   
// This function return the value true if the current bar/candle was just formed
bool NewBar(datetime PreviousBar)
{
    if(PreviousBar < Time[0])
        return(true);
    else
        return(false);
}

int TFSec(int period) 
{
  switch (period) 
  {
    case PERIOD_M1: return(60);
    case PERIOD_M5: return(320);
    case PERIOD_M15: return(900);
    case PERIOD_M30: return(1800);
    case PERIOD_H1: return(3600);
    case PERIOD_H4: return(1400);
    case PERIOD_D1: return(86400);
    case PERIOD_W1: return(604800);
    case PERIOD_MN1: return(2592000);
 }
 
  return (period);
 } 
  
 string TF2Str(int period2) 
{
  switch (period2) 
  {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN");
 }
 
  return (period2);
}