//+------------------------------------------------------------------+
//|                                            Brian_HH_LL_Daily.mq4 |
//|                                           Copyright  2011, Kris |
//| Time optimised for Forex.com                                     |
//+------------------------------------------------------------------+
#property copyright "  2011, Kris "
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 C'200,000,000' // Red        // 1.000
#property indicator_color2 C'150,150,150' // Silver     // Pivot
#property indicator_color3 C'100,100,100' // Gray       // 0.500
#property indicator_color4 C'000,200,000' // Crimson    // 0.000

//Input Params
extern string PivotStart = "22:00";
extern string PivotEnd =   "22:00";

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];

double LastHigh,LastLow,LastClose;
double Fib1000,Fib0500,Fib0000,FibPivot;

int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,160);
   SetIndexBuffer(0,Buffer1);
   SetIndexLabel(0,"Fibonacci 1.000");
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,167);
   SetIndexBuffer(1,Buffer2);
   SetIndexLabel(1,"Fibonacci 0.500");
   
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,160);
   SetIndexBuffer(2,Buffer3);
   SetIndexLabel(2,"Fibonacci Pivot");
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,160);
   SetIndexBuffer(3,Buffer4);
   SetIndexLabel(3,"Fibonacci 0.000");
   
   return(0); }

int deinit() {
	ObjectDelete("Fib100");
	ObjectDelete("Fib500");
	ObjectDelete("FibPiv");
	ObjectDelete("Fib000");
	Comment("");
	return(0); }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  if (Period() > 240) return(0);		//Chart cannot be higher than H4
      BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      if ((PivotEnd == "00:00" && BarTime>=PivotEnd && BarDay>LastBarDay) || (BarTime>=PivotEnd && LastBarTime<PivotEnd))
      {  CloseBar = i + 1;
         
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
      if ((PivotStart == "00:00" && BarTime>=PivotStart && BarDay>LastBarDay) || (BarTime>=PivotStart && LastBarTime<PivotStart))
      { OpenBar = i; }
      
      if (OpenBar>0)
      { drawIndicators(i);  }
      }
   return(0);
   }
   
void calculatePivotRangeValues(int openBar, int closeBar)
   {
   LastHigh = High[Highest(NULL, 0, MODE_HIGH, (openBar - closeBar + 1), closeBar)];
   LastLow = Low[Lowest(NULL, 0, MODE_LOW, (openBar - closeBar + 1), closeBar)];
   LastClose = Close[closeBar];
   double R  = (LastHigh - LastLow);
   Fib1000  = LastHigh;
   FibPivot = (LastHigh+LastLow+LastClose)/3;
   Fib0500  = LastLow + R * 0.5;
   Fib0000  = LastLow;
   }

void drawIndicators(int curBar)
   {
   Buffer1[curBar]=Fib1000;
   Buffer2[curBar]=FibPivot;
   Buffer3[curBar]=Fib0500;
   Buffer4[curBar]=Fib0000;
   
   DoLabel( "Fib100", Buffer1[0], indicator_color1 );
   DoLabel( "FibPiv", Buffer2[0], indicator_color2 );
   DoLabel( "Fib500", Buffer3[0], indicator_color3 );
   DoLabel( "Fib000", Buffer4[0], indicator_color4 );
   return(0); }
	
void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }
//+-----------------------------------------------------------------------------------------+
//|                                        THE END                                          |
//+-----------------------------------------------------------------------------------------+