//+------------------------------------------------------------------+
//|                                                   BsktBrs HL.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
// Based on smj_BasketBars1.5

#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Green
#property indicator_width1 2

#property indicator_color2 FireBrick
#property indicator_width2 2

#property indicator_color3 Black
#property indicator_width3 2

#property indicator_color4 Green
#property indicator_width4 0

#property indicator_color5 FireBrick
#property indicator_width5 0

#property indicator_color6 Black
#property indicator_width6 4

extern string  Group = "Grp";
extern bool    ShowPriceLine = True;

string  Pair1 = "GBPUSD";
string  Pair2 = "EURGBP";
string  Pair3 = "GBPJPY";
string  Pair4 = "USDCHF";
string  Pair5 = "NZDUSD";
string  Pair6 = "AUDJPY";
string  Pair7 = "EURJPY";

string  Pair8 = "EURUSD";
string  Pair9 = "USDJPY";
string  Pair10 = "AUDUSD";
string  Pair11 = "NZDJPY";
string  Pair12 = "GBPCHF";
string  Pair13 = "CHFJPY";
string  Pair14 = "EURCHF";


int            Tperiod = 0;

//---- buffers

double BbufferGreen[];
double BbufferRed[];
double ObufferBlack[];
double HbufferGreen[];
double HbufferRed[];
double LbufferBlack[];
//+------------------------------------------------------------------+




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

//   IndicatorShortName("BsktBrs HL = "+Group);
   string short_name=NULL;
   IndicatorShortName(short_name);

//---- indicators
   
   SetIndexBuffer(0,BbufferGreen);
   SetIndexStyle(0,DRAW_HISTOGRAM,0);
   SetIndexLabel(0,"BasketClose"); 
    
   SetIndexBuffer(1,BbufferRed);
   SetIndexStyle(1,DRAW_HISTOGRAM,0);
   SetIndexLabel(1,NULL); 

   SetIndexBuffer(2,ObufferBlack);
   SetIndexStyle(2,DRAW_HISTOGRAM,0);
   SetIndexLabel(2,"BasketOpen");
      
   SetIndexBuffer(3,HbufferGreen);
   SetIndexStyle(3,DRAW_HISTOGRAM,0);
   SetIndexLabel(3,"BasketHigh");
   
   SetIndexBuffer(4,HbufferRed);
   SetIndexStyle(4,DRAW_HISTOGRAM,0);
   SetIndexLabel(4,NULL);
    
   SetIndexBuffer(5,LbufferBlack);
   SetIndexStyle(5,DRAW_HISTOGRAM,0);
   SetIndexLabel(5,"BasketLow"); 
 
//----
return(0);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
return(0);
}
//+------------------------------------------------------------------+
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//for (int VisBarsRefresh = MathMax(WindowFirstVisibleBar(), Bars-IndicatorCounted());  VisBarsRefresh>=0;  VisBarsRefresh--){

   int    counted_bars=IndicatorCounted();
   double ch,cl,cb,co;

   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted

   if(counted_bars>0) counted_bars--;

   int pos=Bars-counted_bars;
  
   while (pos>=0) 
   {
      ch = ((gethigh(Pair1,Tperiod,pos)+gethigh(Pair2,Tperiod,pos)+gethigh(Pair3,Tperiod,pos)+
            gethigh(Pair4,Tperiod,pos)+gethigh(Pair5,Tperiod,pos)+gethigh(Pair6,Tperiod,pos)+
            gethigh(Pair7,Tperiod,pos)+
            gethigh(Pair8,Tperiod,pos)+gethigh(Pair9,Tperiod,pos)+gethigh(Pair10,Tperiod,pos)+
            gethigh(Pair11,Tperiod,pos)+gethigh(Pair12,Tperiod,pos)+gethigh(Pair13,Tperiod,pos)+
            gethigh(Pair14,Tperiod,pos)) /1000 )  ;
            
      cl = ((getlow(Pair1,Tperiod,pos)+getlow(Pair2,Tperiod,pos)+getlow(Pair3,Tperiod,pos)+
            getlow(Pair4,Tperiod,pos)+getlow(Pair5,Tperiod,pos)+
            getlow(Pair6,Tperiod,pos)+getlow(Pair7,Tperiod,pos)+
            getlow(Pair8,Tperiod,pos)+getlow(Pair9,Tperiod,pos)+getlow(Pair10,Tperiod,pos)+
            getlow(Pair11,Tperiod,pos)+getlow(Pair12,Tperiod,pos)+getlow(Pair13,Tperiod,pos)+
            getlow(Pair14,Tperiod,pos))   /1000 );
      
      cb = ((getbid(Pair1,Tperiod,pos)+getbid(Pair2,Tperiod,pos)+getbid(Pair3,Tperiod,pos)+
            getbid(Pair4,Tperiod,pos)+getbid(Pair5,Tperiod,pos)+
            getbid(Pair6,Tperiod,pos)+getbid(Pair7,Tperiod,pos)+
            getbid(Pair8,Tperiod,pos)+getbid(Pair9,Tperiod,pos)+getbid(Pair10,Tperiod,pos)+
            getbid(Pair11,Tperiod,pos)+getbid(Pair12,Tperiod,pos)+getbid(Pair13,Tperiod,pos)+
            getbid(Pair14,Tperiod,pos))  /1000  ); 

      co = ((getopen(Pair1,Tperiod,pos)+getopen(Pair2,Tperiod,pos)+getopen(Pair3,Tperiod,pos)+
            getopen(Pair4,Tperiod,pos)+getopen(Pair5,Tperiod,pos)+
            getopen(Pair6,Tperiod,pos)+getopen(Pair7,Tperiod,pos)+
            getopen(Pair8,Tperiod,pos)+getopen(Pair9,Tperiod,pos)+getopen(Pair10,Tperiod,pos)+
            getopen(Pair11,Tperiod,pos)+getopen(Pair12,Tperiod,pos)+getopen(Pair13,Tperiod,pos)+
            getopen(Pair14,Tperiod,pos))  /1000  );
                    
      if (ShowPriceLine==True) ObjectCreate("CurrentPrice",OBJ_HLINE,1,Green,cb);
      if (ShowPriceLine==True) ObjectSet("CurrentPrice",OBJ_HLINE,cb);

      if (cb >= co)         //  up bar
         {   
            BbufferGreen[pos] = cb;
         
            BbufferRed[pos] = co;
            ObufferBlack[pos] = co;

            HbufferGreen[pos] = ch;
         
            HbufferRed[pos] = cl;
            LbufferBlack[pos] = cl;
            
            if (ShowPriceLine==True) ObjectSet("CurrentPrice",OBJPROP_COLOR,Green);
         }
      else                 //  down bar
         {
            BbufferRed[pos] = co;
         
            BbufferGreen[pos] = cb;         
            ObufferBlack[pos] = cb;

            HbufferRed[pos] = ch;
         
            HbufferGreen[pos] = cl;
            LbufferBlack[pos] = cl;
            
            if (ShowPriceLine==True) ObjectSet("CurrentPrice",OBJPROP_COLOR,FireBrick);
         }

     pos--;
   }
   
   
//----
return(0);
}
//}  
  
  
//+------------------------------------------------------------------+

double gethigh(string c,int tf, int ni)
   {
     if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   chigh = iHigh(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(chigh);
   }   

double getlow(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   clow = iLow(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(clow);
   } 
   
double getbid(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   cbid = iClose(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(cbid);
   }     

  
double getopen(string c,int tf, int ni)
   {
      if ( StringLen(c) < 6 ) return(0);
      RefreshRates();
      double   copen = iOpen(c,tf,ni)/MarketInfo(c,MODE_POINT);
      return(copen);
   }     
             