//+--------------------------------------------------------------------------------------+
//|                                           Fourier Extrapolation of Indicator 1.1.mq4 |
//|                                                               Copyright  2008, gpwr |
//|                                                                   vlad1004@yahoo.com |
//+--------------------------------------------------------------------------------------+

///1.3 added color,alerts with line and arrows functions 
///1.3.1 added some default basic indies
///by leledc///
#property copyright "Copyright  2009, gpwr"
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 White
#property indicator_color2 CLR_NONE
#property indicator_color3 Blue
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
//Global constants
#define pi 3.141592653589793238462643383279502884197169399375105820974944592
#define  BUY   1
#define  SELL -1
extern string Comment1="Put the name of indi here exactly as shown below";
extern string Comment2="Rsi,Cci,ZLMacd,StdDev,Wpr,DSStoch,Cycle,DeMarker,AO,AC";
extern string IndiName="AO";
extern string Comment3="Indicator Settings";
extern int Period_Indi=13;
extern int Applied_Price=0;
extern string Comment4="Double Smooth Stoch Settings";
extern int StochasticPeriod = 55;
extern int EMAPeriod        = 15;
extern string Comment5="ZeroLag Macd Settings";
extern int    FastEMA        = 12;
extern int    SlowEMA        = 26;
extern int    SignalEMA      =  9;
extern string Comment6="FFT Settings";
extern int     LastBar  =0;  //Last bar in the past data
extern int     PastBars =300; //500 //Number of past bars
extern int     FutBars  =50;  //Number of bars to predict 
extern int     HarmNo   =20;   //Number of frequencies; HarmNo=0 computes PastBars harmonics
extern double  FreqTOL  =0.0001;//Tolerance of frequency calculation
extern bool ShowBaseIndiBuff=false;
extern string Comment7="Alert Options";
extern bool Draw_Line= false;
extern int WidthLine=2;
extern bool Draw_Arrow=true;
extern int WidthArrow=1;
extern int ArrowUp=233;
extern int ArrowDown=234;
extern color colorup=DodgerBlue;
extern color colordown=Red;
extern bool AlertOn=false;
extern int distance = 5;
extern bool Five_digit_broker=true;

//Indicator buffers
double BaseIndiBuff[];
double FFTBuff[];
double FutureValueBuff[];
double FFT_UpBuff[];
double FFT_DownBuff[];

//Global variables
string shortname;
int DistanceArrowUp,DistanceArrowDown;
bool TurnedUp = false;
bool TurnedDown = false;
int count,trend,LastSignal;

int init()
{
     IndicatorBuffers(5);

   if(HarmNo==0 || HarmNo>PastBars)
    HarmNo=PastBars;
   SetIndexBuffer(0,BaseIndiBuff);
   SetIndexBuffer(1,FFTBuff);
   SetIndexBuffer(2,FutureValueBuff);
   SetIndexBuffer(3,FFT_UpBuff);
   SetIndexBuffer(4,FFT_DownBuff);
  if( ShowBaseIndiBuff){
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   }else
   {
    SetIndexStyle(0,DRAW_NONE);
   }
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,2);
   SetIndexShift(1,-LastBar);//past data vector 0..PastBars-1; 0 corresponds to bar=LastBar
   SetIndexShift(2,FutBars-LastBar);//future data vector i=0..FutBars; FutBars corresponds to bar=LastBar
   SetIndexShift(3,-LastBar);
   SetIndexShift(4,-LastBar);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
return(0);
}

int deinit(){
DeleteObjects();
return(0);}

int start()
{
DeleteObjects();
WindowRedraw();
int limit,i;
int counted_bars = IndicatorCounted();
if(counted_bars > 0) 
counted_bars--;
if (counted_bars<0)
 return(-1);
limit = PastBars; 
/////////////////////five or four digits broker
if (Five_digit_broker==true){
DistanceArrowUp=distance*10;
if (Period()==PERIOD_M15){
DistanceArrowDown=((distance+5)*10);
}
else if (Period()==PERIOD_M30 ){
DistanceArrowDown=((distance+10)*10);
}
else if (Period()==PERIOD_H1 ){
DistanceArrowDown=((distance+13)*10);
}
else if(Period()==PERIOD_H4 ){
DistanceArrowDown=((distance+32)*10);
}
else if (Period()==PERIOD_D1){
DistanceArrowDown=((distance+50)*10);
}
else if (Period()==PERIOD_W1){
DistanceArrowDown=((distance+200)*10);
}
else if(Period()==PERIOD_MN1){
DistanceArrowDown=((distance+400)*10);
}
else 
{
DistanceArrowDown=((distance+5)*10);
}
 }
else if (Five_digit_broker==false){
DistanceArrowUp=distance;
 if (Period()==PERIOD_M15){
DistanceArrowDown=((distance+5));
}
else if (Period()==PERIOD_M30 ){
DistanceArrowDown=((distance+10));
}
else if (Period()==PERIOD_H1 ){
DistanceArrowDown=((distance+13));
}
else if(Period()==PERIOD_H4 ){
DistanceArrowDown=((distance+32));
}
else if (Period()==PERIOD_D1){
DistanceArrowDown=((distance+50));
}
else if (Period()==PERIOD_W1){
DistanceArrowDown=((distance+200));
}
else if(Period()==PERIOD_MN1){
DistanceArrowDown=((distance+400));
}
else 
{
DistanceArrowDown=(distance+3);
}
}
//////////////InitializeArray///////////////// 
  ArrayInitialize(BaseIndiBuff,EMPTY_VALUE);
  ArrayInitialize(FFTBuff,EMPTY_VALUE);
  ArrayInitialize(FutureValueBuff,EMPTY_VALUE);  
  ArrayInitialize(FFT_UpBuff,EMPTY_VALUE);
  ArrayInitialize(FFT_DownBuff,EMPTY_VALUE);
//Choose indicator and find the average of its PastBars past values
   double x[]; //stores indicator values
   ArrayResize(x,PastBars);
   double av=0.0;
for( i=0;i<limit;i++)
  //for( i=-LastBar;i<PastBars;i++)
   {
//////////////////////Choosing base indicator
   if( IndiName=="Rsi"){
 BaseIndiBuff[i+LastBar]=0.5+iRSI(NULL,0,Period_Indi,Applied_Price,i+LastBar)/100.0;
 }
else  if( IndiName=="Cci"){
 BaseIndiBuff[i+LastBar]=0.5+iCCI(NULL,0,Period_Indi,Applied_Price,i+LastBar)/100.0;
 }
 else if( IndiName=="Wpr"){
 BaseIndiBuff[i+LastBar]=0.5+iWPR(NULL,0,Period_Indi,i+LastBar)/100.0;
 }
 else if ( IndiName=="ZLMacd"){ 
  BaseIndiBuff[i+LastBar]=0.5+iCustom(NULL,0,"Zerolag MACD",FastEMA,SlowEMA,SignalEMA,0,i+LastBar)/100.0; 
 }
 else if ( IndiName=="DSStoch"){
 BaseIndiBuff[i+LastBar]=0.5+iCustom(NULL,0,"Double Smoothed Stochastic",StochasticPeriod,EMAPeriod,0,i+LastBar)/100.0; 
 }
 else if( IndiName=="StdDev"){
  BaseIndiBuff[i+LastBar]=0.5+iStdDev(NULL,0,Period_Indi,0,MODE_EMA,Applied_Price,i+LastBar)/100.0; 
  }
   else if( IndiName=="Cycle"){
  BaseIndiBuff[i+LastBar]=0.5+iCustom(NULL,0,"Cycle_GJH4",0,i+LastBar)/100.0; 
  }
 else if( IndiName=="DeMarker"){
  BaseIndiBuff[i+LastBar]=0.5+iDeMarker(NULL,0,Period_Indi,i+LastBar)/100.0; 
  }
  else if( IndiName=="AC"){
  BaseIndiBuff[i+LastBar]=0.5+iAC(NULL,0,i+LastBar)/100.0; 
  }
  else if( IndiName=="AO"){
  BaseIndiBuff[i+LastBar]=0.5+iAO(NULL,0,i+LastBar)/100.0; 
  }
  else {
  Alert("Attention please!Type in the name exactly as shown in the Comment2!!!");
  }
///////////////////////////////////////////////////////////////////
IndicatorShortName(WindowExpertName()+"("+IndiName+")"); 

     
      if(i>=0)
      {
         x[i]=BaseIndiBuff[i+LastBar];
         av+=x[i];
      }
   }
   av/=PastBars;
   
//Prepare modeled data
for( i=0;i<limit;i++)
   {
      FFTBuff[i]=av;
      if(i<=FutBars) FutureValueBuff[i]=av;
   }

//Fit trigomometric series
   double w,m,c,s;
   for(int harm=1;harm<=HarmNo;harm++)
   {
      Freq(x,w,m,c,s);
      for( i=0;i<limit;i++)
      {
         FFTBuff[i]+=m+c*MathCos(w*i)+s*MathSin(w*i);
         if(i<=FutBars)
         FutureValueBuff[i]+=m+c*MathCos(w*i)-s*MathSin(w*i);
      }       
   }
   
//Reorder the predicted vector
   for(i=0;i<=(FutBars-1)/2;i++)
   {
      double tmp=FutureValueBuff[i];
      FutureValueBuff[i]=FutureValueBuff[FutBars-i];
      FutureValueBuff[FutBars-i]=tmp;
   } 
//////////////////////Color FFT////////////////////// 
 for( i=limit;i>=0;i--)
{      
      if(FFTBuff[i]>FFTBuff[i+1]  )
      {
           FFT_UpBuff[i]=FFTBuff[i];
           FFT_UpBuff[i+1]=FFTBuff[i+1];
           trend=1;
           }
        if(FFTBuff[i]<FFTBuff[i+1]  )
      {
           FFT_DownBuff[i]=FFTBuff[i];
           FFT_DownBuff[i+1]=FFTBuff[i+1];
             trend =-1;
           }
//////////////////////////////////////////////////////////
////////////Alerts with line and arrows//////////////////
      if (i>0){
         if ( trend >0 && LastSignal!=BUY){
           LastSignal=BUY;
          if (Draw_Line ){
          DrawLine(i, "Up");
          }
            if (Draw_Arrow  ){
        DrawArrow(i,"Up" );
         }
          if  (AlertOn  && i==1 && !TurnedDown )
           { 
           Alert("FFT is changing UP on"+" "+Symbol()," ",Period()+" "+"minute charts");
            TurnedUp = false;
            TurnedDown = true;
     }
           }
           }
            if (i>0){
            if ( trend <0 && LastSignal!=SELL){
           LastSignal=SELL;
          if (Draw_Line ){
          DrawLine(i, "Down");
          }
            if (Draw_Arrow  ){
         DrawArrow(i,"Down" );
         }
          if  (AlertOn  && i==1 && !TurnedDown )
           { 
           Alert("FFT is changing DOWN on"+" "+Symbol()," ",Period()+" "+"minute charts");
            TurnedUp = false;
            TurnedDown = true;
     }
    }    
   } 
  }
   return(0);
}
 ////////////////////////////////Functions/////////////////////////////////////
     
//+--------------------------------------------------------------------------------------+
//Quinn and Fernandes algorithm
void Freq(double x[], double& w, double& m, double& c, double& s)
{
   double z[],num,den;
   ArrayResize(z,PastBars);
   double a=0.0;
   double b=2.0;
   z[0]=x[0]-FFTBuff[0];
   while(MathAbs(a-b)>FreqTOL)
   {
      a=b;
      z[1]=x[1]-FFTBuff[1]+a*z[0];
      num=z[0]*z[1];
      den=z[0]*z[0];
      for(int i=2;i<PastBars;i++)
      {
         z[i]=x[i]-FFTBuff[i]+a*z[i-1]-z[i-2];
         num+=z[i-1]*(z[i]+z[i-2]);
         den+=z[i-1]*z[i-1];
      }
      b=num/den;
   }
    w=MathArccos(MathMax(MathMin(b/2.0,1),-1)); //mladen correction
  // w=MathArccos(b/2.0);
   Fit(x,w,m,c,s);
   return;
}
//+-------------------------------------------------------------------------+
void Fit(double x[], double w, double& m, double& c, double& s)
{
   double Sc=0.0;
   double Ss=0.0;
   double Scc=0.0;
   double Sss=0.0;
   double Scs=0.0;
   double Sx=0.0;
   double Sxc=0.0;
   double Sxs=0.0;
   for(int i=0;i<PastBars;i++)
   {
      double cos=MathCos(w*i);
      double sin=MathSin(w*i);
      Sc+=cos;
      Ss+=sin;
      Scc+=cos*cos;
      Sss+=sin*sin;
      Scs+=cos*sin;
      Sx+=(x[i]-FFTBuff[i]);
      Sxc+=(x[i]-FFTBuff[i])*cos;
      Sxs+=(x[i]-FFTBuff[i])*sin;
   }
   Sc/=PastBars;
   Ss/=PastBars;
   Scc/=PastBars;
   Sss/=PastBars;
   Scs/=PastBars;
   Sx/=PastBars;
   Sxc/=PastBars;
   Sxs/=PastBars;
   if(w==0.0)
   {
      m=Sx;
      c=0.0;
      s=0.0;
   }
   else
   {
      //calculating c, s, and m
      double den=MathPow(Scs-Sc*Ss,2)-(Scc-Sc*Sc)*(Sss-Ss*Ss);
      c=((Sxs-Sx*Ss)*(Scs-Sc*Ss)-(Sxc-Sx*Sc)*(Sss-Ss*Ss))/den;
      s=((Sxc-Sx*Sc)*(Scs-Sc*Ss)-(Sxs-Sx*Ss)*(Scc-Sc*Sc))/den;
      m=Sx-c*Sc-s*Ss;
   }
   return;
}
///////////////////////////////////////////////
//            DrawLineFunction              //
/////////////////////////////////////////////
void DrawLine(int i,string type)
{    
      count++;
      string name = StringConcatenate(WindowExpertName(),count);
      ObjectCreate(name,OBJ_VLINE,0,Time[i],1);
      if (type=="Up")
         {
           
          ObjectSet(name, OBJPROP_WIDTH, WidthLine);
         ObjectSet(name, OBJPROP_COLOR, colorup);
         }
      else if (type=="Down")
         {
           ObjectSet(name, OBJPROP_WIDTH, WidthLine);
         ObjectSet(name, OBJPROP_COLOR, colordown);
         }
         }
 ///////////////////////////////////////////////
//            DrawArrowFunction             //
/////////////////////////////////////////////
void DrawArrow(int i,string type)
{     count++;

      string name = StringConcatenate(WindowExpertName(),count);
     ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      if (type=="Up")
         {
            ObjectSet(name,OBJPROP_PRICE1,Low[i]-(DistanceArrowUp *Point));
            ObjectSet(name,OBJPROP_ARROWCODE,ArrowUp);
            ObjectSet(name,OBJPROP_COLOR,colorup);
            ObjectSet(name,OBJPROP_WIDTH,WidthArrow);
         }
      else if (type=="Down")
         {
            ObjectSet(name,OBJPROP_PRICE1,High[i]+(DistanceArrowDown*Point));
            ObjectSet(name,OBJPROP_ARROWCODE,ArrowDown);
             ObjectSet(name,OBJPROP_WIDTH,WidthArrow);
            ObjectSet(name,OBJPROP_COLOR,colordown);
        }
            }
///////////////////////////////////////////////
//             DeleteFunction               //
/////////////////////////////////////////////
void DeleteObjects()
{
   while(count>0) { 
   ObjectDelete(StringConcatenate(WindowExpertName(),count)); 
   count--; }
}


