#property copyright "crzee8s" //crzee8s@aol.com
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

#define IND_RANGE 6
#define IND_MAX   3
#define IND_MIN   -3

#property indicator_maximum   IND_MAX
#property indicator_minimum   IND_MIN

#property indicator_level1    -2
#property indicator_level2    -1
#property indicator_level3    0
#property indicator_level4    1
#property indicator_level5    2

//This is an oscillator created based around the Sixths indicator from the Nanning Bob 4hr trading post. 
//Auto bar count and sixths level calculation are pulled from the source of SIXTHS SCREEN VER 3.6_DC auto barCount
//The below code aside from that is a bolt on to the indicator to act as an oscillator.

//---- input parameters
extern int barCount = 0;

//---- buffers
double sixthsOsc[];

int init()
{
   
   SetIndexStyle(0, DRAW_LINE, 0, 2, indicator_color1);
   SetIndexBuffer(0, sixthsOsc);
   IndicatorShortName("Sixths Oscillator");

   //auto bar count taken from MagnumFreak Sixths 3.6 w AutoBar count
   if (barCount == 0)
   {
      //Set up the barCount. H1 TF first. Default barcount set at 170
      if (StringSubstr(Symbol(), 0, 6) == "AUDCAD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "AUDCHF") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "AUDJPY") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "AUDNZD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "AUDSGD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "AUDUSD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "CADCHF") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "CADJPY") { barCount = 180; }
      if (StringSubstr(Symbol(), 0, 6) == "CHFJPY") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "CHFSGD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURAUD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURCAD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURCHF") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURGBP") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURJPY") { barCount = 180; }
      if (StringSubstr(Symbol(), 0, 6) == "EURNZD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURSGD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "EURUSD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "GBPAUD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "GBPCAD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "GBPCHF") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "GBPJPY") { barCount = 180; }
      if (StringSubstr(Symbol(), 0, 6) == "GBPUSD") { barCount = 155; }
      if (StringSubstr(Symbol(), 0, 6) == "NZDCAD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "NZDCHF") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "NZDJPY") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "NZDUSD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "SGDJPY") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "USDCAD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "USDCHF") { barCount = 180; }
      if (StringSubstr(Symbol(), 0, 6) == "USDHKD") { barCount = 170; }
      if (StringSubstr(Symbol(), 0, 6) == "USDJPY") { barCount = 180; }
      if (StringSubstr(Symbol(), 0, 6) == "USDSGD") { barCount = 170; }
      
      
      //Now accommodate different time frames
      double multiplier;
      if (Period() == PERIOD_M1) multiplier = 60;
      if (Period() == PERIOD_M5) multiplier = 12;
      if (Period() == PERIOD_M15) multiplier = 4;
      if (Period() == PERIOD_M30) multiplier = 2;
      if (Period() == PERIOD_H1) multiplier = 1;
      if (Period() == PERIOD_H4) multiplier = 0.25;
      if (Period() == PERIOD_D1) multiplier = 0.25 / 6;
   
      double dbarCount = barCount;
      dbarCount *= multiplier;
      barCount = dbarCount;
   }
         
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{  
   double base;
   double range;
   double sixth;
   double diff;
      
   int i;
   int limit;
   int countedBars = IndicatorCounted();
   Comment(DoubleToStr(countedBars,1));
   
   //bounds check
   if (countedBars < 0) 
       return (-1);
   
   if (countedBars > 0) 
       countedBars--;
   
   //set limit
   limit = Bars - countedBars;

   //gather data 
   for (i = 0; i < limit; i++)
   {       
      //compute sixths level
      range = High[iHighest(NULL, 0, MODE_HIGH, barCount, i)] - Low[iLowest(NULL, 0, MODE_LOW, barCount, i)];      
      sixth = range / 6;
      
      //calculate 0/6
      base = Low[iLowest(NULL, 0, MODE_LOW, barCount, i)];
      
      //if not current bar
      if (i > 0)
      {
         //calc osc val using close
         diff = (iClose(NULL, NULL, i) - base);
      }
      else
      {  
         //calc osc val using bid
         diff = (Bid - base);
      }
      
      //calculate and scale from -100 to 100
      sixthsOsc[i] = (diff / range * IND_RANGE);
      sixthsOsc[i] -= IND_MAX;
   }
              
   return(0);
   
}

