//+------------------------------------------------------------------+
//|          Logical Trader Signals Generator EA by SteveHopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  startline "Range start line"
#define  endline "Range end line"
#define  rangehighline "Range high line"
#define  rangelowline "Range low line"
#define  bufferhighline "Buffer high line"
#define  bufferlowline "Buffer low line"
#define  pivotline "Pivot line"
#define  pivothighline "Pivot range high line"
#define  pivotlowline "Pivot range low line"
#define  up "Up"
#define  down "Down"
#define  none "None"

/*
void DisplayUserFeedback()
void DeleteObjects()
datetime hhmm_to_time(double hhmm)
void DisplayLines()
void RemoveLines()
void GetBias()


*/

extern string  dr="----Range inputs----";
extern int     RangeShift=0;
extern double  RangeStartTime=7;
extern int     RangeHours=20;
extern color   RangeLineColour=Yellow;
//extern int     RangeTimeFrame=60;
extern color   RangeLineHiLoColour=Turquoise;
extern int     PipsBuffer=5;

extern string  pi="----Pivot inputs----";
extern int     PivotTimeFrame = 1440;
extern int     PivotShift = 1;//Can remove the extern when this becomes an indi
extern color   PivotColour=Blue;

extern string  ge="----General inputs----";
extern bool    CriminalHasSundayCandle=true;
extern int     DisplayGapSize=30;
extern bool    SendEmailAlert=true;

string         GvName, Gap, ScreenMessage, Bias;
int            OldBars;
double         prh, prl, pp, pd; //Pivot range hi lo, price pivot, price differential
double         RangeHigh, RangeLow,  RangeHighBuff, RangeLowBuff;
datetime       TimeCrossed;
string         OldBias = none;
bool           AlertSent = false;
double         TimeToAlert;

void DisplayUserFeedback()
{
   
   if (IsTesting() && !IsVisualMode()) return;
   
   ScreenMessage = "";
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL );
//double         prh, prl, pp, pd; //Pivot range hi lo, price pivot, price differential
//double         RangeHigh, RangeLow,  RangeHighBuff, RangeLowBuff;

   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Range high: ", DoubleToStr(RangeHigh, Digits), " (", DoubleToStr(RangeHighBuff, Digits), ")", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Range low: ", DoubleToStr(RangeLow, Digits), " (", DoubleToStr(RangeLowBuff, Digits), ")", NL);
   
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Pivot range high: ", DoubleToStr(prh, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Pivot: ", DoubleToStr(pp, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Pivot range low: ", DoubleToStr(prl, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Pivot differential: ", DoubleToStr(pd, Digits), NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading bias is: ", Bias, NL);
   if (Bias != none) 
   {
      if (TimeCrossed > 0) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Time crossed: ", TimeToStr(TimeCrossed, TIME_MINUTES|TIME_SECONDS), NL);
      //if (TimeToAlert > 0) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Time to alert: ", TimeToAlert / 60, " minutes ", MathMod(TimeToAlert, 60), " seconds", NL);
      int min = TimeToAlert / 60;
      if (TimeToAlert > 0) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Time to alert: ", min, " minutes ", MathMod(TimeToAlert, 60), " seconds", NL);
   }//if (Bias != none) 
   
   
   Comment(ScreenMessage);

}//void DisplayUserFeedback()

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{


   Gap="";
   if (DisplayGapSize >0)
   {
      for (int cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }//if (DisplayGapSize >0)
   
      //Adapt PipsBuffer to x digit criminals
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   PipsBuffer*= multiplier;

   
   
   start();
   
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{

   DeleteObjects();
}
  
void DeleteObjects()
{


   ObjectDelete(startline);
   ObjectDelete(endline);
   ObjectDelete(rangehighline);
   ObjectDelete(rangelowline);
   ObjectDelete(bufferhighline);
   ObjectDelete(bufferlowline);
   ObjectDelete(pivotline);
   ObjectDelete(pivothighline);
   ObjectDelete(pivotlowline);
   

}//End void DeleteObjects()

void DisplayLines()
{

   if (TimeLocal() < (RangeStartTime * 3600) + (Period() * 60) 
       || TimeHour(TimeLocal()) > (RangeStartTime + RangeHours) ) return;
   
      //Draw range start line
   datetime ConvertedStartTime = hhmm_to_time(RangeStartTime);
   ConvertedStartTime-= 24 * 60 * 60 * RangeShift;
   ObjectDelete(startline);
   ObjectCreate(startline, OBJ_VLINE, 0, ConvertedStartTime, 0);
   ObjectSet(startline, OBJPROP_COLOR, RangeLineColour);
   ObjectSet(startline, OBJPROP_STYLE, STYLE_SOLID);
   
   //Draw range end line
   datetime EndTime = ConvertedStartTime + (RangeHours + 1) * 3600;
   ObjectDelete(endline);
   ObjectCreate(endline, OBJ_VLINE, 0, EndTime, 0);
   ObjectSet(endline, OBJPROP_COLOR, RangeLineColour);
   ObjectSet(endline, OBJPROP_STYLE, STYLE_DASH);
   
   //Calculate shift. There must be a better way
   double shift;
   for (int cc = 0; cc < iBars(NULL, Period()); cc++)
   {
      if (iTime(NULL, Period(), cc) == ConvertedStartTime) break;
      shift++;      
   }//for (int cc = 0; cc < iBars(null, Period()); cc++)
   
   //Draw range High
   RangeHigh = iHigh(NULL, Period(), shift);
   ObjectDelete(rangehighline);
   ObjectCreate(rangehighline,OBJ_TREND,0,ConvertedStartTime,RangeHigh,EndTime,iHigh(NULL, Period(), shift));
   ObjectSet(rangehighline,OBJPROP_RAY,false); 
   ObjectSet(rangehighline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(rangehighline,OBJPROP_COLOR,RangeLineHiLoColour); 
   
   //Draw range Low
   RangeLow = iLow(NULL, Period(), shift);
   ObjectDelete(rangelowline);
   ObjectCreate(rangelowline,OBJ_TREND,0,ConvertedStartTime,RangeLow,EndTime,iLow(NULL, Period(), shift));
   ObjectSet(rangelowline,OBJPROP_RAY,false); 
   ObjectSet(rangelowline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(rangelowline,OBJPROP_COLOR,RangeLineHiLoColour); 
   
   
   //Draw upper buffer line
   RangeHighBuff = NormalizeDouble(iHigh(NULL, Period(), shift) + (PipsBuffer * Point), Digits);
   ObjectDelete(bufferhighline);
   ObjectCreate(bufferhighline,OBJ_TREND,0,ConvertedStartTime,RangeHighBuff,EndTime,RangeHighBuff);
   ObjectSet(bufferhighline,OBJPROP_RAY,false); 
   ObjectSet(bufferhighline,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet(bufferhighline,OBJPROP_COLOR,RangeLineHiLoColour); 
   
   //Draw lower buffer line
   RangeLowBuff = NormalizeDouble(iLow(NULL, Period(), shift) - (PipsBuffer * Point), Digits);
   ObjectDelete(bufferlowline);
   ObjectCreate(bufferlowline,OBJ_TREND,0,ConvertedStartTime,RangeLowBuff,EndTime,RangeLowBuff);
   ObjectSet(bufferlowline,OBJPROP_RAY,false); 
   ObjectSet(bufferlowline,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet(bufferlowline,OBJPROP_COLOR,RangeLineHiLoColour); 
   

   //Calculate the pivot range
   //Accommodate Sunday candle
   if (CriminalHasSundayCandle && PivotShift == 1)
   {
      int day = (TimeDayOfWeek(TimeLocal()) );
      if (day == 1) PivotShift = 2;
   }//if (CriminalHasSundayCandle && PivotShift == 1)
   
   double high = iHigh(NULL, PivotTimeFrame, PivotShift);
   double low = iLow(NULL, PivotTimeFrame, PivotShift);
   double close = iClose(NULL, PivotTimeFrame, PivotShift);
   
   //Pivot price
   pp = NormalizeDouble((high + low + close) /3, Digits);
   //Pivot differential
   pd = MathAbs(pp - (high + low) / 2);
   //Pivot range high
   prh = NormalizeDouble(pp + pd, Digits);
   //Pivot range low
   prl = NormalizeDouble(pp - pd, Digits);
   
   //Draw upper pivot line
   ObjectDelete(pivothighline);
   ObjectCreate(pivothighline,OBJ_TREND,0,ConvertedStartTime,prh,EndTime,prh);
   ObjectSet(pivothighline,OBJPROP_RAY,false); 
   ObjectSet(pivothighline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(pivothighline,OBJPROP_COLOR,PivotColour); 
   
   //Draw pivot line
   ObjectDelete(pivotline);
   ObjectCreate(pivotline,OBJ_TREND,0,ConvertedStartTime,pp,EndTime,pp);
   ObjectSet(pivotline,OBJPROP_RAY,false); 
   ObjectSet(pivotline,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet(pivotline,OBJPROP_COLOR,PivotColour); 
   
   
   //Draw pivot line
   ObjectDelete(pivotlowline);
   ObjectCreate(pivotlowline,OBJ_TREND,0,ConvertedStartTime,prl,EndTime,prl);
   ObjectSet(pivotlowline,OBJPROP_RAY,false); 
   ObjectSet(pivotlowline,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet(pivotlowline,OBJPROP_COLOR,PivotColour); 


}//void DisplayLines()

datetime hhmm_to_time(double hhmm)
{
  return (StrToTime(DoubleToStr(MathFloor(hhmm),0)+":"+DoubleToStr((hhmm-MathFloor(hhmm))*100,0)) );
}//End datetime hhmm_to_time(double hhmm)

void RemoveLines()
{

   if (TimeHour(TimeLocal()) >= (RangeStartTime + RangeHours) && ObjectFind(startline) > -1)
   {
      DeleteObjects();
   }//if (TimeHour(TimeLocal()) > (RangeStartTime + RangeHours) && ObjectFind(startline) > -1) )

   
}//void RemoveLines()

void GetBias()
{

   Bias = none;
   
   RefreshRates();
   if (Bid < RangeLowBuff) Bias = down;
   if (Bid > RangeHighBuff) Bias = up;
   

}//End void GetBias()


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

   //Should the lines be displayed?
   if (OldBars != Bars)
   {
      DisplayLines();
      OldBars = Bars;
      AlertSent = false;
   }//if (OldBars != Bars)
   
   
   //Should the lines be deleted?
   RemoveLines();
   
   //Get current trading bias
   OldBias = Bias;
   GetBias();
   if (Bias == none) TimeCrossed = 0;
   
   //Look for a cross of range high/low
   RefreshRates();
   //Use Bid as everyone has this showing on their chart
   if (OldBias == none && (Bid > RangeHighBuff || Bid < RangeLowBuff) )
   {
      TimeCrossed = TimeLocal();   
   }//if (Bias == none && (Bid > RangeHighBuff || Bid < RangeLowBuff) )
   OldBias = Bias;
   
   //Can the ea send an alert
   if (TimeCrossed > 0)
   {
      double tf = (Period() * 60) / 2;
      if (Period() == 0) tf = Period() / 2;
      double target = TimeCrossed + tf;
      if (TimeLocal() >= target && !AlertSent)
      {
         Alert("Logical trader ", Symbol(), " alert. ",  TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) );
         if (SendEmailAlert) SendMail("Logical trader alert", Symbol() + " alert. " +  TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS ));         
         AlertSent = true;
         TimeCrossed = 0;
         TimeToAlert = 0;
      }//if (TimeLocal() >= target && !AlertSent)
      if (!AlertSent)
      {
         TimeToAlert = target - TimeLocal();
      }//if (!AlertSent)
      
   }//if (TimeCrossed > 0)
   
   
   DisplayUserFeedback();

}
//+------------------------------------------------------------------+