//+------------------------------------------------------------------+
//|                                             Opening_Range_DT.mq4 |
//|                                      Copyright  2008, Kris Pivo |
//|                                           kris.pivo[at]gmail.com |
//|                                                     21 July 2008 |
//+------------------------------------------------------------------+
#property copyright " Kris  2010 "
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 C'000,250,000' // Opening Range Hi +4
#property indicator_color2 C'000,150,000' // Opening Range Hi +3
#property indicator_color3 C'000,150,000' // Opening Range Hi +2
#property indicator_color4 C'000,150,000' // Opening Range Hi +1
#property indicator_color5 C'150,000,000' // Opening Range Lo -1
#property indicator_color6 C'150,000,000' // Opening Range Lo -2
#property indicator_color7 C'150,000,000' // Opening Range Lo -3
#property indicator_color8 C'250,000,000' // Opening Range Lo -4
extern string  Opening_Hour   = "~~~~~~~~~~~~~~~~~~~~~~~";
extern string RangeStart = "12:00";
extern string RangeEnd   = "12:00";
extern string  Profit_Targets = "~~~~~~~~~~~~~~~~~~~~~~~";
extern int SigConfirm = 8;
extern int Target1    = 25;
extern int Target2    = 50;
extern int Target3    = 75;
extern int Target4    = 100;

double Buffer0[];    // Opening Range Hi +4
double Buffer1[];    // Opening Range Hi +3
double Buffer2[];    // Opening Range Hi +2
double Buffer3[];    // Opening Range Hi +1
double Buffer4[];    // Opening Range Lo -1
double Buffer5[];    // Opening Range Lo -2
double Buffer6[];    // Opening Range Lo -3
double Buffer7[];    // Opening Range Lo -4

double OpenHi, OpenHS, OpenLo, OpenLS;
double HT1, HT2, HT3, HT4;
double LT1, LT2, LT3, LT4;
int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,160);
   SetIndexBuffer(0,Buffer0);
   SetIndexLabel(0,"OR Hi +4");

   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,160);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"OR Hi +3");

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,160);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"OR Hi +2");
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,160);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"OR Lo +1");
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,160);
   SetIndexBuffer(4,Buffer4);
   SetIndexLabel(4,"OR Lo -1");
   
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,160);
   SetIndexBuffer(5,Buffer5);
   SetIndexLabel(5,"OR Lo -2");

   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,160);
   SetIndexBuffer(6,Buffer6);
   SetIndexLabel(6,"OR Lo -3");

   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,160);
   SetIndexBuffer(7,Buffer7);
   SetIndexLabel(7,"OR Lo -4");
   
   return(0); }

int deinit()
   {
	ObjectDelete("ORHi4");
	ObjectDelete("ORHi3");
	ObjectDelete("ORHi2");
	ObjectDelete("ORHi1");
	ObjectDelete("ORLo1");
	ObjectDelete("ORLo2");
	ObjectDelete("ORLo3");
	ObjectDelete("ORLo4");
	Comment("");
	return(0);
   }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;    
   for(int i=Bars; i>=0; i--)
   {  BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      //handle if Opening Range start/end is 00:00
      if ((RangeEnd == "00:00" && BarTime>=RangeEnd && BarDay>LastBarDay) || (BarTime>=RangeEnd && LastBarTime<RangeEnd))
      {  CloseBar = i + 1;
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      if ((RangeStart == "00:00" && BarTime>=RangeStart && BarDay>LastBarDay) || (BarTime>=RangeStart && LastBarTime<RangeStart))
      { OpenBar = i; }
      if (OpenBar>0)
      { drawIndicators(i);  } }
   return(0);}
void calculatePivotRangeValues(int openBar, int closeBar)
   {
   OpenHi = High[closeBar-1];
   OpenLo = Low[closeBar-1];
   OpenHS = OpenHi + SigConfirm * Point;
   OpenLS = OpenLo - SigConfirm * Point;

   HT4 = OpenHS + Target4 * Point;
   HT3 = OpenHS + Target3 * Point;
   HT2 = OpenHS + Target2 * Point;
   HT1 = OpenHS + Target1 * Point;
   LT1 = OpenLS - Target1 * Point;
   LT2 = OpenLS - Target2 * Point;
   LT3 = OpenLS - Target3 * Point;
   LT4 = OpenLS - Target4 * Point;
   }
void drawIndicators(int curBar)
   {
   Buffer0[curBar]=HT4;
   Buffer1[curBar]=HT3;
   Buffer2[curBar]=HT2;
   Buffer3[curBar]=HT1;
   Buffer4[curBar]=LT1;
   Buffer5[curBar]=LT2;
   Buffer6[curBar]=LT3;
   Buffer7[curBar]=LT4;
   
   DoLabel( "ORHi4", Buffer0[0], indicator_color1 ) ;	
   DoLabel( "ORHi3", Buffer1[0], indicator_color2 ) ;	
   DoLabel( "ORHi2", Buffer2[0], indicator_color3 ) ;	
   DoLabel( "ORHi1", Buffer3[0], indicator_color4 ) ;
   DoLabel( "ORLo1", Buffer4[0], indicator_color5 ) ;	
   DoLabel( "ORLo2", Buffer5[0], indicator_color6 ) ;
   DoLabel( "ORLo3", Buffer6[0], indicator_color7 ) ;
   DoLabel( "ORLo4", Buffer7[0], indicator_color8 ) ;
	return(0); }
   void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//                                  THE END                               |
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

