//+------------------------------------------------------------------+
//|                                          Opening_Range_Daily.mq4 |
//|                                           Copyright  2008, Kris |
//|                                           kris.pivo[at]gmail.com |
//|                                                    12 April 2008 |
//+------------------------------------------------------------------+
#property copyright " Kris  2010 "
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 C'000,255,000'    // Opening Range Buy Signal
#property indicator_color2 C'000,150,000'    // Opening Range High
#property indicator_color3 C'150,000,000'    // Opening Range Low
#property indicator_color4 C'255,000,000'    // Opening Range Sell Signal

extern string  Opening_Hour         = "~~~~~~~~~~~~~~~~~~~~~~~";
extern string PivotStart = "12:00";
extern string PivotEnd =   "12:00";
extern int SigConfirm  =   8;
double Buffer0[]; // Opening Range Buy Signal
double Buffer1[]; // Opening Range High
double Buffer2[]; // Opening Range Low
double Buffer3[]; // Opening Range Sell Signal

double OpenHi, OpenHiSig, OpenLo, OpenLoSig;

int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,167);
   SetIndexBuffer(0,Buffer0);
   SetIndexLabel(0,"OR Hi Sig");

   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,160);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"OR High");

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,160);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"OR Low");
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,167);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"OR Lo Sig");
   
   return(0); }

int deinit()
   {
	ObjectDelete("ORH");
	ObjectDelete("ORL");
	Comment("");
	return(0);
   }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      //handle if Opening Range start/end is 00:00
      if ((PivotEnd == "00:00" && BarTime>=PivotEnd && BarDay>LastBarDay) || (BarTime>=PivotEnd && LastBarTime<PivotEnd))
      {  CloseBar = i + 1;
         
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
      if ((PivotStart == "00:00" && BarTime>=PivotStart && BarDay>LastBarDay) || (BarTime>=PivotStart && LastBarTime<PivotStart))
      { OpenBar = i; }
      
      if (OpenBar>0)
      { drawIndicators(i);  } }
   return(0);}
void calculatePivotRangeValues(int openBar, int closeBar)
   {
   OpenHi = High[closeBar-1];
   OpenLo = Low[closeBar-1];
   OpenHiSig = OpenHi + SigConfirm * Point;
   OpenLoSig = OpenLo - SigConfirm * Point;
   }

void drawIndicators(int curBar)
   {
   Buffer0[curBar]=OpenHiSig;
   Buffer1[curBar]=OpenHi;
   Buffer2[curBar]=OpenLo;
   Buffer3[curBar]=OpenLoSig;
   
   DoLabel( "ORH", Buffer0[0], indicator_color1 ) ;	
   DoLabel( "ORL", Buffer3[0], indicator_color4 ) ;
	return(0); }
	
void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//                                  THE END                               |
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+    

