//+------------------------------------------------------------------+
//|                                                        Range.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


//---- input parameters
extern double	Lots=0.1;
extern double	Pips=20;
extern double	TP=30;
extern double	SL=20;
extern bool	  Buy=true;
extern bool	  Sell=true;


//+------------------------------------------------------------------+
//| expert initialization function								   |
//+------------------------------------------------------------------+
int init()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function								 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function											|
//+------------------------------------------------------------------+
int start() {
   //----
   int ticket;
   // The spread is included in the sl and tp calculations
   double buy_price = Ask + Pips*Point;
   double sell_price = Bid - Pips*Point;
	
   // Buy order
   ticket=OrderSend(Symbol(),OP_BUYSTOP, Lots, buy_price,2,Bid+(Pips-SL)*Point,Ask+(Pips+TP)*Point,"Buy order ",00001,0,CLR_NONE);
   if (ticket<0) {
	  Print("OrderSend failed with error #",GetLastError());
	  return(0);
   }

   // Sell order
   ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,sell_price,2,Ask-(Pips-SL)*Point,Bid-(Pips+TP)*Point,"Sell order ",00002,0,CLR_NONE);
   if(ticket<0) {
	  Print("OrderSend failed with error #",GetLastError());
	  return(0);
   }

   //----
   return(0);
}
//+------------------------------------------------------------------+

