//+------------------------------------------------------------------+
//|                                                  TEMA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 DarkOrange
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int  TEMA1Period = 12;
extern int  TEMA1Price  = PRICE_CLOSE;
extern int  TEMA2Period = 26;
extern int  TEMA2Price  = PRICE_CLOSE;

//
//
//
//
//

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double trend[];
double tBuffer[][6];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,trend);
      if (TEMA1Period>TEMA2Period)
      {
         int temp = TEMA1Period;
                    TEMA1Period = TEMA2Period;
                    TEMA2Period = temp;
      }                    
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      buffer1[i] = iTema(iMA(NULL,0,1,0,MODE_SMA,TEMA1Price,i),TEMA1Period,i,0);
      buffer2[i] = iTema(iMA(NULL,0,1,0,MODE_SMA,TEMA2Price,i),TEMA2Period,i,3);
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
      trend[i]   = trend[i+1];
      
         if (buffer1[i]>buffer2[i]) trend[i] =  1;
         if (buffer1[i]<buffer2[i]) trend[i] = -1;
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert("up");
         if (trend[whichBar] == -1) doAlert("down");
      }
   }

   //
   //
   //
   //
   //
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TEMA "+TEMA1Period+" crossed TEMA "+TEMA2Period+" ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TEMA ribbon "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iTema(double price,int period,int shift,int forBuffer)
{
   double alpha = 2.0 /(1.0 + period);
   int i = Bars-shift-1;
   if (i < 1)
      {
         tBuffer[i][0+forBuffer] = price;
         tBuffer[i][1+forBuffer] = price;
         tBuffer[i][2+forBuffer] = price;
      }
   else
      {
         tBuffer[i][0+forBuffer] = tBuffer[i-1][0+forBuffer]+alpha*(price                  -tBuffer[i-1][0+forBuffer]);
         tBuffer[i][1+forBuffer] = tBuffer[i-1][1+forBuffer]+alpha*(tBuffer[i][0+forBuffer]-tBuffer[i-1][1+forBuffer]);
         tBuffer[i][2+forBuffer] = tBuffer[i-1][2+forBuffer]+alpha*(tBuffer[i][1+forBuffer]-tBuffer[i-1][2+forBuffer]);
      }
   return(3*tBuffer[i][0+forBuffer] - 3*tBuffer[i][1+forBuffer] + tBuffer[i][2+forBuffer]);
}