//+------------------------------------------------------------------+
//|                                           hedge_dashboard_v3.mq4 |
//|                                                  Pah & Trade4fun |
//|  http://www.forexfactory.com/showthread.php?p=4636877#post4636877|
//|  Bryon,Don,Eric,Cedric,Richard,Xaphod,Andy,McL                      |
//|  god bless you all                                               | 
//+------------------------------------------------------------------+

string vsn = "hedge_dashboard_v3";

/*

fixes, changes history
----------------------------------------------------------------------------------------
v3 02/07/2011
added 5/9 ma pip difference
included three 4 xJPY & 5 xCHF groups
removed optional compact mode otherwise display is just too wide
now determines pair suffix from chart current symbol e.g. EURUSDm or AUDUSDfxd or whatever
three5 alarm did not respect 30 minute alarm intrval
----------------------------------------------------------------------------------------
v2 23/06/2011

fix bug in THREE 3 display
values displayed for EURJPY were actually for GBPUSD and for GBPJPY were actually EURJPY
added automatic server GMT offset calcs
added option to show SWAP values from McL
post release fix (next day) to update gmt setting hourly
----------------------------------------------------------------------------------------
*/

#property copyright "Paul and Eelco"
#property link      "free4all"

#import "kernel32.dll"
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import
#define TIME_ZONE_ID_DAYLIGHT  2

#property indicator_chart_window

#define Day.Friday 5
#define alert.period.reset.secs 1800

extern bool Enable.Alerts = true;
bool Compact.Mode = true;
extern bool RG.Profit.Loss = true;
extern bool Dynamic.Spread.Values = false;
extern bool Show.Swap.Values = true;
extern bool Auto.Calc.Server.GMT.Offset = true;
extern int  Server.GMT.Offset.Hours = 0;

/*
string AVERAGES_PAIRS;
string CORE_PAIRS;
string SIX_PAIRS;
string AMIGOS_PAIRS;
string THREE1_PAIRS;
string THREE2_PAIRS;
string THREE3_PAIRS;
string THREE4_PAIRS;
string THREE5_PAIRS;
*/

string Arrowup;
string Arrowdown;

string sAUDUSD;
string sNZDJPY;
string sGBPCHF;
string sEURUSD;
string sEURCHF;
string sCHFJPY;
string sUSDJPY;

string sUSDCHF;
string sEURGBP;
string sNZDUSD;
string sGBPUSD;
string sEURJPY;
string sAUDJPY;
string sGBPJPY;

//you may want to allow the user to input their colour choices
color arrow.up.color = Lime;
color arrow.down.color = Red;

color profit.val.color = Lime;
color loss.val.color = Red;

color text.red = Red;
color text.lime  = Lime;
color text.plain = White;
color text.total = Gold;

double local.gmt.offset.hours = 0;

//Lucida Console or FixedSys fonts keep columns of text and numbers nicely aligned 
string text.font = "Lucida Console";
string arrow.font = "Wingdings";

int font.size = 11;

datetime no.alerts.before.averages;
datetime no.alerts.before.eight;
datetime no.alerts.before.core;
datetime no.alerts.before.six;
datetime no.alerts.before.amigos;
datetime no.alerts.before.three1;
datetime no.alerts.before.three2;
datetime no.alerts.before.three3;
datetime no.alerts.before.three4;
datetime no.alerts.before.three5;

int fri.shift = 0;

int open15.shift = 0;

bool shifts.initialized = false;

//having these allows you to add things to the code without having to
//go through many lines, changing all the existing values. layout changes are much easier
int start.x.pos;
int start.y.pos;
int current.x.pos;
int current.y.pos;
int save.y.pos;
int save.x.pos;
int arrow.x.inc;
int row.y.inc;
int col.x.inc;

string sfx = ""; //symbol suffix for e.g. EURUSDm pairs, etc

void SetSymbolNames()
{
  sfx = StringSubstr(Symbol(), 6, 6); //get suffix from current chart symbol
  
  sAUDUSD = "AUDUSD"+sfx;
  sNZDJPY = "NZDJPY"+sfx;
  sGBPCHF = "GBPCHF"+sfx;
  sEURUSD = "EURUSD"+sfx;
  sEURCHF = "EURCHF"+sfx;
  sCHFJPY = "CHFJPY"+sfx;
  sUSDJPY = "USDJPY"+sfx;

  sUSDCHF = "USDCHF"+sfx;
  sEURGBP = "EURGBP"+sfx;
  sNZDUSD = "NZDUSD"+sfx;
  sGBPUSD = "GBPUSD"+sfx;
  sEURJPY = "EURJPY"+sfx;
  sAUDJPY = "AUDJPY"+sfx;
  sGBPJPY = "GBPJPY"+sfx;
}

double TimeZoneLocal()
{
	int TZInfoArray[43];

	if ( GetTimeZoneInformation(TZInfoArray)==TIME_ZONE_ID_DAYLIGHT )
		return((TZInfoArray[0]+TZInfoArray[42])/(-60.0));
	else//TIME_ZONE_ID_STANDARD or TIME_ZONE_ID_UNKNOWN
		return(TZInfoArray[0]/(-60.0));
}

int GetServerGMTOffset()
{
   datetime server.time = TimeCurrent();
   
   datetime local.time = TimeLocal();
   
   local.gmt.offset.hours = TimeZoneLocal();

   double gmt.time = local.time - ( local.gmt.offset.hours * 60 * 60 );

	 int server.gmt.diff.mins = ( server.time - gmt.time ) / 60;
	 server.gmt.diff.mins = MathRound(server.gmt.diff.mins/30.0) * 30;

   return(MathRound(server.gmt.diff.mins/60));
	 
   return(0);
}

//this makes it easy to align columns of numbers
string PadVal(double Val, int Prec, int PadSpc)
{
  string S = DoubleToStr(Val, Prec);
  
  while ( StringLen(S) <= PadSpc ) S = " " + S;
  
  return(S); 
}

//this draws the label and arrow based on the symbol and value passed
//and then increments the x value ready for the next line
//you use this same code for every pair group
void DrawRowData(string prefix, string symbl, double week.val, double day.val, double ma.diff, color text.color, bool invert = false, int xtra.row = 1)
{
  int arrow.x.offset = 103;
  int arrow.y.offset;
  int value.x.offset = 46;
  
  //PAIR
  string s = StringConcatenate(prefix, symbl);
  
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  
  //ObjectSetText(s, symbl + PadVal(week.val, 0, 4), font.size, text.font, text.color);
  ObjectSetText(s, StringSubstr(symbl,0,6), font.size, text.font, text.color);

  //WEEKLY VALUE
  s = StringConcatenate(prefix,"val.", symbl);
  
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + value.x.offset);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  
  color c = text.color;
  
  if ( RG.Profit.Loss )
  {
    if ( week.val < 0.00 ) c = loss.val.color; else c = profit.val.color;
  }
  
  ObjectSetText(s, PadVal(week.val, 0, 4), font.size, text.font, c);
  
  //chr 233 = solid arrow up, 234 = down
  
  //WEEKLY ARROW  
  string week.arrow.char;
  color week.arrow.color = arrow.up.color;
  
  //this just swaps the value used for choosing the arrow
  //based on the buy/sell pair group & the invert parameter
  double week.v;
  
  if ( invert ) week.v = 0 - week.val; else week.v = week.val; 
   
  if ( week.v > 0 )
  {
    week.arrow.char = CharToStr(233);
    week.arrow.color = arrow.up.color;
    arrow.y.offset = -3;
  }
  else
  {
    week.arrow.char = CharToStr(234);
    week.arrow.color = arrow.down.color;
    arrow.y.offset = 1;
  }
    
  s = StringConcatenate(prefix, ".week.arrow.", symbl);  
  
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0);
  ObjectSetText(s, week.arrow.char, font.size - 1, arrow.font, week.arrow.color);
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + arrow.x.offset);
	ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos + arrow.y.offset);

  //DAILY ARROW
  string day.arrow.char;
  color day.arrow.color = arrow.up.color;

  double day.v;
  
  if ( invert ) day.v = 0 - day.val; else day.v = day.val; 
   
  if ( day.v > 0 )
  {
    day.arrow.char = CharToStr(233);
    day.arrow.color = arrow.up.color;
    arrow.y.offset = -3;
  }
  else
  {
    day.arrow.char = CharToStr(234);
    day.arrow.color = arrow.down.color;
    arrow.y.offset = 1;
  }

  arrow.x.offset += 14;
  
  s = StringConcatenate(prefix, ".day.arrow.", symbl);  
  
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0);
  ObjectSetText(s, day.arrow.char, font.size - 1, arrow.font, day.arrow.color);
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + arrow.x.offset);
	ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos + arrow.y.offset);

  //MA 5/9 difference

  s = StringConcatenate(prefix, "ma.diff.", symbl);  

  c = text.color;
  
  if ( RG.Profit.Loss )
  {
    if ( ma.diff < 0.00 ) c = loss.val.color; else c = profit.val.color;
  }

  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0);
  ObjectSetText(s, PadVal(ma.diff, 0, 4), font.size, text.font, c);
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + arrow.x.offset);
	ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);


  if ( Compact.Mode ) xtra.row = 1;
  
  current.y.pos += ( row.y.inc * xtra.row ); //ready for next line
   
}

void DrawSwapData(string prefix, string symbl, color text.color, int xtra.row = 1)
{
  double dSwapLong  = MarketInfo(symbl, MODE_SWAPLONG);
  double dSwapShort = MarketInfo(symbl, MODE_SWAPSHORT);
  int arrow.x.offset = 103;
  int arrow.y.offset;
  int value.x.offset = 46;
  //PAIR
  string s = StringConcatenate(prefix, symbl);
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  //ObjectSetText(s, symbl + PadVal(week.val, 0, 4), font.size, text.font, text.color);
  ObjectSetText(s, StringSubstr(symbl,0,6), font.size, text.font, text.color);
  //swap long
  s = StringConcatenate(prefix, "vall.", symbl);
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + value.x.offset);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  color c = text.color;
  if ( RG.Profit.Loss )
  {
    if ( dSwapLong < 0.00 ) c = loss.val.color; else c = profit.val.color;
  }
  ObjectSetText(s, PadVal(dSwapLong, 1, 6), font.size, text.font, c);
  value.x.offset += 50;
  //swap short
  s = StringConcatenate(prefix, "vals.", symbl);
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + value.x.offset);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  if ( RG.Profit.Loss )
  {
    if ( dSwapShort < 0.00 ) c = loss.val.color; else c = profit.val.color;
  }
  ObjectSetText(s, PadVal(dSwapShort, 1, 6), font.size, text.font, c);
  current.y.pos += ( row.y.inc * xtra.row ); //ready for next line
}
//headers can all use the same code  
void DrawHeader(string prefix, string text, int xtra.row = 1)
{
  string s = StringConcatenate(prefix, ".hdr");

  ObjectDelete(s);    
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(s, text, font.size, text.font, text.plain);
	ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos);
	ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos); 

  if ( Compact.Mode ) xtra.row = 1;

  current.y.pos += ( row.y.inc * xtra.row );   
	
}

//totals can all use the same code
void DrawTotal(string prefix, string text, double val, int xtra.row = 0)
{
  current.y.pos += row.y.inc; 

  string s = StringConcatenate(prefix, ".ftr");

  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  //ObjectSetText(s, text + PadVal(val, 0, 4), font.size, text.font, text.total);
  ObjectSetText(s, text, font.size, text.font, text.total);
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);

  //VALUE
  
  int value.x.offset = 46;
  
  s = StringConcatenate(s,".val");
  
  ObjectDelete(s);
  ObjectCreate(s, OBJ_LABEL, 0, 0, 0); 
  ObjectSet(s, OBJPROP_XDISTANCE, current.x.pos + value.x.offset);
  ObjectSet(s, OBJPROP_YDISTANCE, current.y.pos);
  
  color c = text.total;
  
  if ( RG.Profit.Loss )
  {
    if ( val < 0.00 ) c = loss.val.color; else c = profit.val.color;
  }

  ObjectSetText(s, PadVal(val, 0, 4), font.size, text.font, c);  
  

  if ( Compact.Mode ) xtra.row = 0;

  current.y.pos += ( row.y.inc * xtra.row );   
}

void RefreshGMTOffset(bool Forced)
{
  //refresh GMT offset if Forced or whenever chart symbol current M1 bar hour != previous M1 bar hour
  
  if ( Forced || ( TimeHour(iTime(NULL, PERIOD_M1, 0)) != TimeHour(iTime(NULL, PERIOD_M1, 1)) ) )
  {
    if (Auto.Calc.Server.GMT.Offset) 
    {
      Server.GMT.Offset.Hours = GetServerGMTOffset();
    }
    else  
    {
      if ( Server.GMT.Offset.Hours > 13 || Server.GMT.Offset.Hours < -12 ) Server.GMT.Offset.Hours = 0;
    }
    //Print("GMT check ", TimeToStr(TimeCurrent(), TIME_MINUTES|TIME_SECONDS), " Server.GMT.Offset.Hours = ", Server.GMT.Offset.Hours);
  }  
}

int init()
{
  
  no.alerts.before.averages = 0;
  no.alerts.before.eight = 0;
  no.alerts.before.core = 0;
  no.alerts.before.six = 0;
  no.alerts.before.amigos = 0;
  no.alerts.before.three1 = 0;
  no.alerts.before.three2 = 0;
  no.alerts.before.three3 = 0;
  no.alerts.before.three4 = 0;
  no.alerts.before.three5 = 0;
  
  local.gmt.offset.hours = 0;

  RefreshGMTOffset(true);
    
  shifts.initialized = false;
  
  SetSymbolNames();
  
  return(0);
}

int deinit()
{

  ObjectsDeleteAll(0);  //clean up the chart
  Comment("");
  return(0);
}

int CalcShifts()
{
  
  int shift = 0;
  
  int hour = TimeHour(iTime(NULL, PERIOD_H1, shift));
  int day = TimeDayOfWeek(iTime(NULL, PERIOD_H1, shift));
  
  int target.hour = 20 + Server.GMT.Offset.Hours;
  int target.day = Day.Friday;
  
  //not sure if these checks will work ??
  
  if ( target.hour >= 24 )
  {
    target.hour -= 24;
    target.day += 1;
  }

  if ( target.hour < 0 )
  {
    target.hour += 24;
    target.day -= 1;
  }
  
  if ( target.day == 6 ) target.day += 1; //avoid looking for saturday bars
  
  while ( ! ( hour == target.hour && day == target.day ) )
  {
    shift++;
    hour = TimeHour(iTime(NULL, PERIOD_H1, shift));
    day = TimeDayOfWeek(iTime(NULL, PERIOD_H1, shift));
    
    if ( shift > (24*8) ) //8 days back & no bar found with target.hour
    {
      shift = 0;
      break;  
    }
  }

  fri.shift = shift;
  
  
  //calc 15 minutes after open shift value
    
  int min = TimeMinute(iTime(NULL, PERIOD_M15, 0));
     hour = TimeHour(iTime(NULL, PERIOD_M15, 0));
  
  int target.min = 15;
      target.hour = 0;

  shift = 0;

  while ( ! ( hour == target.hour && min == target.min ) )
  {
    shift++;
    min = TimeMinute(iTime(NULL, PERIOD_M15, shift));
    hour = TimeHour(iTime(NULL, PERIOD_M15, shift));
    
    if ( shift > (25*4) ) //25 hrs back & no bar found with target.hour/min
    {
      shift = 0;
      break;  
    }
    
  }
  
  open15.shift = shift;
  
  shifts.initialized = true;
    
}

void CheckShifts()
{
  int Min15 = TimeMinute(iTime(NULL, PERIOD_M15, 0));
  
  if ( ( ! shifts.initialized ) || ( Min15 == 0 || Min15 == 15 || Min15 == 30 || Min15 == 45 ) ) CalcShifts();    
  
}

void GetBidAskOpen(string symbl, double& BID, double& ASK, double& WEEK.OPEN, double& DAY.OPEN, double& MA.DIFF)
{ 
  BID = MarketInfo(symbl, MODE_BID);
  ASK = MarketInfo(symbl, MODE_ASK);
  WEEK.OPEN = iOpen(symbl, PERIOD_H1,  fri.shift);
  DAY.OPEN  = iOpen(symbl, PERIOD_M15, open15.shift);
  
  //I'm assuming the ma used in excel is a simple ma and it seems to be calculated as
  //the ((( previous 4 H1 bars close + bid )/5) - (( previous 8 H1 bars close + bid )/9) ) * 10000 (or 100 for JPY)
  //since the ima returns the value already averaged I've multiplied by 4 or 8 before adding to bid and then dividing
  //need to check if it corresponds with the excel values

  double D = MarketInfo(symbl, MODE_DIGITS);

  double mul = 10000;
  
  if ( D == 3 ) mul = 100;
/*  
  //following excel original
  double ma5 = BID;
  for ( int i = 1; i <= 4; i++ ) { ma5 += iClose(symbl, PERIOD_H1, i); }
  ma5 /= 5;
  
  double ma9 = BID;
  for ( i = 1; i <= 8; i++ ) { ma9 += iClose(symbl, PERIOD_H1, i); }
  ma9 /= 9;
  
  MA.DIFF = ( ma5 - ma9 ) * mul;
*/  
  
  MA.DIFF = ((((4 * iMA(symbl, PERIOD_H1, 4, 0, MODE_SMA, PRICE_CLOSE, 1)) + BID )/5) 
          - (((8 * iMA(symbl, PERIOD_H1, 8, 0, MODE_SMA, PRICE_CLOSE, 1)) + BID )/9)) * mul;

  
}
    
int start()
{
  RefreshGMTOffset(false);
  
  if ( Auto.Calc.Server.GMT.Offset )
    Comment(StringConcatenate(" ", vsn, ", local GMT offset hrs: ", local.gmt.offset.hours, ", server GMT offset hrs: ", Server.GMT.Offset.Hours));
  else
    Comment(StringConcatenate(" ", vsn, ", server GMT offset hrs: ", Server.GMT.Offset.Hours));   
  
  CheckShifts();
   
  RefreshRates();
  
    double AUDUSD, AUDUSD.DAY, AUDUSD.BID, AUDUSD.ASK, AUDUSD.WK.OPEN, AUDUSD.DAY.OPEN, AUDUSD.MAD; GetBidAskOpen(sAUDUSD, AUDUSD.BID, AUDUSD.ASK, AUDUSD.WK.OPEN, AUDUSD.DAY.OPEN, AUDUSD.MAD);
    double NZDJPY, NZDJPY.DAY, NZDJPY.BID, NZDJPY.ASK, NZDJPY.WK.OPEN, NZDJPY.DAY.OPEN, NZDJPY.MAD; GetBidAskOpen(sNZDJPY, NZDJPY.BID, NZDJPY.ASK, NZDJPY.WK.OPEN, NZDJPY.DAY.OPEN, NZDJPY.MAD);
    double GBPCHF, GBPCHF.DAY, GBPCHF.BID, GBPCHF.ASK, GBPCHF.WK.OPEN, GBPCHF.DAY.OPEN, GBPCHF.MAD; GetBidAskOpen(sGBPCHF, GBPCHF.BID, GBPCHF.ASK, GBPCHF.WK.OPEN, GBPCHF.DAY.OPEN, GBPCHF.MAD);
    double EURUSD, EURUSD.DAY, EURUSD.BID, EURUSD.ASK, EURUSD.WK.OPEN, EURUSD.DAY.OPEN, EURUSD.MAD; GetBidAskOpen(sEURUSD, EURUSD.BID, EURUSD.ASK, EURUSD.WK.OPEN, EURUSD.DAY.OPEN, EURUSD.MAD);
    double EURCHF, EURCHF.DAY, EURCHF.BID, EURCHF.ASK, EURCHF.WK.OPEN, EURCHF.DAY.OPEN, EURCHF.MAD; GetBidAskOpen(sEURCHF, EURCHF.BID, EURCHF.ASK, EURCHF.WK.OPEN, EURCHF.DAY.OPEN, EURCHF.MAD);
    double CHFJPY, CHFJPY.DAY, CHFJPY.BID, CHFJPY.ASK, CHFJPY.WK.OPEN, CHFJPY.DAY.OPEN, CHFJPY.MAD; GetBidAskOpen(sCHFJPY, CHFJPY.BID, CHFJPY.ASK, CHFJPY.WK.OPEN, CHFJPY.DAY.OPEN, CHFJPY.MAD);
    double USDJPY, USDJPY.DAY, USDJPY.BID, USDJPY.ASK, USDJPY.WK.OPEN, USDJPY.DAY.OPEN, USDJPY.MAD; GetBidAskOpen(sUSDJPY, USDJPY.BID, USDJPY.ASK, USDJPY.WK.OPEN, USDJPY.DAY.OPEN, USDJPY.MAD);
    double USDCHF, USDCHF.DAY, USDCHF.BID, USDCHF.ASK, USDCHF.WK.OPEN, USDCHF.DAY.OPEN, USDCHF.MAD; GetBidAskOpen(sUSDCHF, USDCHF.BID, USDCHF.ASK, USDCHF.WK.OPEN, USDCHF.DAY.OPEN, USDCHF.MAD);
    double EURGBP, EURGBP.DAY, EURGBP.BID, EURGBP.ASK, EURGBP.WK.OPEN, EURGBP.DAY.OPEN, EURGBP.MAD; GetBidAskOpen(sEURGBP, EURGBP.BID, EURGBP.ASK, EURGBP.WK.OPEN, EURGBP.DAY.OPEN, EURGBP.MAD);
    double NZDUSD, NZDUSD.DAY, NZDUSD.BID, NZDUSD.ASK, NZDUSD.WK.OPEN, NZDUSD.DAY.OPEN, NZDUSD.MAD; GetBidAskOpen(sNZDUSD, NZDUSD.BID, NZDUSD.ASK, NZDUSD.WK.OPEN, NZDUSD.DAY.OPEN, NZDUSD.MAD);
    double GBPUSD, GBPUSD.DAY, GBPUSD.BID, GBPUSD.ASK, GBPUSD.WK.OPEN, GBPUSD.DAY.OPEN, GBPUSD.MAD; GetBidAskOpen(sGBPUSD, GBPUSD.BID, GBPUSD.ASK, GBPUSD.WK.OPEN, GBPUSD.DAY.OPEN, GBPUSD.MAD);
    double EURJPY, EURJPY.DAY, EURJPY.BID, EURJPY.ASK, EURJPY.WK.OPEN, EURJPY.DAY.OPEN, EURJPY.MAD; GetBidAskOpen(sEURJPY, EURJPY.BID, EURJPY.ASK, EURJPY.WK.OPEN, EURJPY.DAY.OPEN, EURJPY.MAD);
    double AUDJPY, AUDJPY.DAY, AUDJPY.BID, AUDJPY.ASK, AUDJPY.WK.OPEN, AUDJPY.DAY.OPEN, AUDJPY.MAD; GetBidAskOpen(sAUDJPY, AUDJPY.BID, AUDJPY.ASK, AUDJPY.WK.OPEN, AUDJPY.DAY.OPEN, AUDJPY.MAD);
    double GBPJPY, GBPJPY.DAY, GBPJPY.BID, GBPJPY.ASK, GBPJPY.WK.OPEN, GBPJPY.DAY.OPEN, GBPJPY.MAD; GetBidAskOpen(sGBPJPY, GBPJPY.BID, GBPJPY.ASK, GBPJPY.WK.OPEN, GBPJPY.DAY.OPEN, GBPJPY.MAD);
    
    //SPREADS maybe these shouldn't be fixed values
    double USDCHF.SPRD = 0.0004;
    double EURGBP.SPRD = 0.0003;
    double NZDUSD.SPRD = 0.0005;
    double GBPUSD.SPRD = 0.0004;
    double EURJPY.SPRD = 0.04;
    double AUDJPY.SPRD = 0.12;
    double GBPJPY.SPRD = 0.08;
    //additional for EIGHT group
    double NZDJPY.SPRD = 0.022;
    double AUDUSD.SPRD = 0.0002;
    
    

    if ( Dynamic.Spread.Values )
    {
      USDCHF.SPRD = MarketInfo(sUSDCHF, MODE_SPREAD)*MarketInfo(sUSDCHF, MODE_POINT);
      EURGBP.SPRD = MarketInfo(sEURGBP, MODE_SPREAD)*MarketInfo(sEURGBP, MODE_POINT);
      NZDUSD.SPRD = MarketInfo(sNZDUSD, MODE_SPREAD)*MarketInfo(sNZDUSD, MODE_POINT);
      GBPUSD.SPRD = MarketInfo(sGBPUSD, MODE_SPREAD)*MarketInfo(sGBPUSD, MODE_POINT);
      EURJPY.SPRD = MarketInfo(sEURJPY, MODE_SPREAD)*MarketInfo(sEURJPY, MODE_POINT);
      AUDJPY.SPRD = MarketInfo(sAUDJPY, MODE_SPREAD)*MarketInfo(sAUDJPY, MODE_POINT);
      GBPJPY.SPRD = MarketInfo(sGBPJPY, MODE_SPREAD)*MarketInfo(sGBPJPY, MODE_POINT);
      NZDJPY.SPRD = MarketInfo(sNZDJPY, MODE_SPREAD)*MarketInfo(sNZDJPY, MODE_POINT);
      AUDUSD.SPRD = MarketInfo(sAUDUSD, MODE_SPREAD)*MarketInfo(sAUDUSD, MODE_POINT);
    }

//enable this to see the difference compared to the fixed spreads
//Comment(USDCHF.SPRD,": ",EURGBP.SPRD,": ",NZDUSD.SPRD,": ",GBPUSD.SPRD,": ",EURJPY.SPRD,": ",AUDJPY.SPRD,": ",GBPJPY.SPRD);
      
    //WEEKLY VALUES 
    //SELLS   
    AUDUSD = (AUDUSD.WK.OPEN-AUDUSD.ASK)*10000;
    NZDJPY = ((NZDJPY.WK.OPEN-NZDJPY.ASK)*100)/((NZDJPY.ASK+NZDJPY.BID)/2)*100*((NZDUSD.ASK+NZDUSD.BID)/2);
    GBPCHF = ((GBPCHF.WK.OPEN-GBPCHF.ASK)*10000)/((GBPCHF.ASK+GBPCHF.BID)/2)*((GBPUSD.ASK+GBPUSD.BID)/2);
    EURUSD = (EURUSD.WK.OPEN-EURUSD.ASK)*10000;
    EURCHF = ((EURCHF.WK.OPEN-EURCHF.ASK)*10000)/((EURCHF.ASK+EURCHF.BID)/2)*((EURUSD.ASK+EURUSD.BID)/2);
    CHFJPY = ((CHFJPY.WK.OPEN-CHFJPY.ASK)*100)/((CHFJPY.ASK+CHFJPY.BID)/2)*100*((USDCHF.ASK+USDCHF.BID)/2);
    USDJPY = ((USDJPY.WK.OPEN-USDJPY.ASK)*100)/((USDJPY.ASK+USDJPY.BID)/2)*100;

    //BUYS
    USDCHF = ((USDCHF.BID-USDCHF.WK.OPEN-USDCHF.SPRD)*10000)/((USDCHF.ASK+USDCHF.BID)/2);
    EURGBP = ((EURGBP.BID-EURGBP.WK.OPEN-EURGBP.SPRD)*10000)/((EURGBP.ASK+EURGBP.BID)/2)*((EURUSD.ASK+EURUSD.BID)/2);
    NZDUSD = (NZDUSD.BID-NZDUSD.WK.OPEN-NZDUSD.SPRD)*10000;
    GBPUSD = (GBPUSD.BID-GBPUSD.WK.OPEN-GBPUSD.SPRD)*10000;
    EURJPY = ((EURJPY.BID-EURJPY.WK.OPEN-EURJPY.SPRD)*100)/((EURJPY.ASK+EURJPY.BID)/2)*100*((EURUSD.ASK+EURUSD.BID)/2);
    AUDJPY = ((AUDJPY.BID-AUDJPY.WK.OPEN-AUDJPY.SPRD)*100)/((AUDJPY.ASK+AUDJPY.BID)/2)*100*((AUDUSD.ASK+AUDUSD.BID)/2);
    GBPJPY = ((GBPJPY.BID-GBPJPY.WK.OPEN-GBPJPY.SPRD)*100)/((GBPJPY.ASK+GBPJPY.BID)/2)*100*((GBPUSD.ASK+GBPUSD.BID)/2);

    //ADDITIONAL VARS FOR EIGHT DUE TO SOME OPPOSITE BUY/SELL PAIRS
    
    double NZDJPY_BUY = ((NZDJPY.BID-NZDJPY.WK.OPEN-NZDJPY.SPRD)*100)/((NZDJPY.ASK+NZDJPY.BID)/2)*100*((NZDUSD.ASK+NZDUSD.BID)/2);
    double GBPUSD_SELL = (GBPUSD.WK.OPEN-GBPUSD.ASK)*10000;
    double NZDUSD_SELL = (NZDUSD.WK.OPEN-NZDUSD.ASK)*10000;
    
    //DAILY VALUES
    //I'VE CALCULATED THESE USING THE SAME REFERENCE TO THE USD PAIRS AS THE WEEKLY CALCS
    
    //SELLS
    AUDUSD.DAY = (AUDUSD.DAY.OPEN-AUDUSD.ASK)*10000;
    NZDJPY.DAY = ((NZDJPY.DAY.OPEN-NZDJPY.ASK)*100)/((NZDJPY.ASK+NZDJPY.BID)/2)*100*((NZDUSD.ASK+NZDUSD.BID)/2);
    GBPCHF.DAY = ((GBPCHF.DAY.OPEN-GBPCHF.ASK)*10000)/((GBPCHF.ASK+GBPCHF.BID)/2)*((GBPUSD.ASK+GBPUSD.BID)/2);
    EURUSD.DAY = (EURUSD.DAY.OPEN-EURUSD.ASK)*10000;
    EURCHF.DAY = ((EURCHF.DAY.OPEN-EURCHF.ASK)*10000)/((EURCHF.ASK+EURCHF.BID)/2)*((EURUSD.ASK+EURUSD.BID)/2);
    CHFJPY.DAY = ((CHFJPY.DAY.OPEN-CHFJPY.ASK)*100)/((CHFJPY.ASK+CHFJPY.BID)/2)*100*((USDCHF.ASK+USDCHF.BID)/2);
    USDJPY.DAY = ((USDJPY.DAY.OPEN-USDJPY.ASK)*100)/((USDJPY.ASK+USDJPY.BID)/2)*100;
    
    //BUYS
    USDCHF.DAY = ((USDCHF.BID-USDCHF.DAY.OPEN-USDCHF.SPRD)*10000)/((USDCHF.ASK+USDCHF.BID)/2);
    EURGBP.DAY = ((EURGBP.BID-EURGBP.DAY.OPEN-EURGBP.SPRD)*10000)/((EURGBP.ASK+EURGBP.BID)/2)*((EURUSD.ASK+EURUSD.BID)/2);
    NZDUSD.DAY = (NZDUSD.BID-NZDUSD.DAY.OPEN-NZDUSD.SPRD)*10000;
    GBPUSD.DAY = (GBPUSD.BID-GBPUSD.DAY.OPEN-GBPUSD.SPRD)*10000;
    EURJPY.DAY = ((EURJPY.BID-EURJPY.DAY.OPEN-EURJPY.SPRD)*100)/((EURJPY.ASK+EURJPY.BID)/2)*100*((EURUSD.ASK+EURUSD.BID)/2);
    AUDJPY.DAY = ((AUDJPY.BID-AUDJPY.DAY.OPEN-AUDJPY.SPRD)*100)/((AUDJPY.ASK+AUDJPY.BID)/2)*100*((AUDUSD.ASK+AUDUSD.BID)/2);
    GBPJPY.DAY = ((GBPJPY.BID-GBPJPY.DAY.OPEN-GBPJPY.SPRD)*100)/((GBPJPY.ASK+GBPJPY.BID)/2)*100*((GBPUSD.ASK+GBPUSD.BID)/2);

    //ADDITIONAL VARS FOR EIGHT DUE TO SOME OPPOSITE BUY/SELL PAIRS

    double NZDJPY_BUY.DAY = ((NZDJPY.BID-NZDJPY.DAY.OPEN-NZDJPY.SPRD)*100)/((NZDJPY.ASK+NZDJPY.BID)/2)*100*((NZDUSD.ASK+NZDUSD.BID)/2);
    double GBPUSD_SELL.DAY = (GBPUSD.DAY.OPEN-GBPUSD.ASK)*10000;
    double NZDUSD_SELL.DAY = (NZDUSD.DAY.OPEN-NZDUSD.ASK)*10000;

    //WEEK VALUES
    double CORE = AUDUSD + NZDJPY + EURUSD + CHFJPY + USDJPY;    
    double AMIGOS = GBPCHF + CHFJPY + EURJPY; 
    double THREE1 = EURUSD + EURGBP + GBPUSD;
    double THREE2 = GBPCHF + USDCHF + GBPUSD;
    double THREE3 = EURGBP + EURJPY + GBPJPY;
    double THREE4 = USDJPY + EURJPY + GBPJPY;
    double THREE5 = USDCHF + EURCHF + GBPCHF;

    //double ??? THESIX = USDJPY + EURJPY + GBPJPY;
    double THESIX = EURUSD + USDJPY + EURGBP + GBPUSD + EURJPY + GBPJPY;

    double AVERAGES = AUDUSD + NZDJPY + GBPCHF + EURUSD + EURCHF + CHFJPY + USDJPY + 
                      USDCHF + EURGBP + NZDUSD + GBPUSD + EURJPY + AUDJPY + GBPJPY;   
                      
    double EIGHT = AUDJPY + EURJPY + GBPJPY + NZDJPY_BUY +
                   AUDUSD + EURUSD + GBPUSD_SELL + NZDUSD_SELL;

    //DAY VALUES
    double CORE.DAY = AUDUSD.DAY + NZDJPY.DAY + EURUSD.DAY + CHFJPY.DAY + USDJPY.DAY;    
    double AMIGOS.DAY = GBPCHF.DAY + CHFJPY.DAY + EURJPY.DAY; 
    double THREE1.DAY = EURUSD.DAY + EURGBP.DAY + GBPUSD.DAY;
    double THREE2.DAY = GBPCHF.DAY + USDCHF.DAY + GBPUSD.DAY;
    double THREE3.DAY = EURGBP.DAY + EURJPY.DAY + GBPJPY.DAY;
    double THREE4.DAY = USDJPY.DAY + EURJPY.DAY + GBPJPY.DAY;
    double THREE5.DAY = USDCHF.DAY + EURCHF.DAY + GBPCHF.DAY;

    //double ??? THESIX = USDJPY + EURJPY + GBPJPY;
    double THESIX.DAY = EURUSD.DAY + USDJPY.DAY + EURGBP.DAY + GBPUSD.DAY + EURJPY.DAY + GBPJPY.DAY;

    double AVERAGES.DAY = AUDUSD.DAY + NZDJPY.DAY + GBPCHF.DAY + EURUSD.DAY + EURCHF.DAY + CHFJPY.DAY + USDJPY.DAY + 
                          USDCHF.DAY + EURGBP.DAY + NZDUSD.DAY + GBPUSD.DAY + EURJPY.DAY + AUDJPY.DAY + GBPJPY.DAY;   

    double EIGHT.DAY = AUDJPY.DAY + EURJPY.DAY + GBPJPY.DAY + NZDJPY_BUY.DAY +
                   AUDUSD.DAY + EURUSD.DAY + GBPUSD_SELL.DAY + NZDUSD_SELL.DAY;

    //using the block style below is easier to change when the layout needs changing in future
    //I've made it so that there are only 3 columns but
    //they could easily each have their own columns again
    //this way takes up less space
    
    start.x.pos = 8;
    start.y.pos = 14;    
    
    row.y.inc = 16;
    col.x.inc = 180;

    //BLOCK AVERAGES
    current.x.pos = start.x.pos;
    current.y.pos = start.y.pos;

    string pfx = "avges."; //this is used as the label prefix, change for each block
        
    DrawHeader(pfx, "AVERAGES     W D  ma");
    
    DrawRowData(pfx, sAUDUSD, AUDUSD, AUDUSD.DAY, AUDUSD.MAD, text.red, true);
    DrawRowData(pfx, sNZDJPY, NZDJPY, NZDJPY.DAY, NZDJPY.MAD, text.red, true);
    DrawRowData(pfx, sGBPCHF, GBPCHF, GBPCHF.DAY, GBPCHF.MAD, text.red, true);
    DrawRowData(pfx, sEURUSD, EURUSD, EURUSD.DAY, EURUSD.MAD, text.red, true);
    DrawRowData(pfx, sEURCHF, EURCHF, EURCHF.DAY, EURCHF.MAD, text.red, true);
    DrawRowData(pfx, sCHFJPY, CHFJPY, CHFJPY.DAY, CHFJPY.MAD, text.red, true);
    DrawRowData(pfx, sUSDJPY, USDJPY, USDJPY.DAY, USDJPY.MAD, text.red, true);

    current.y.pos += row.y.inc; //blank line between sells & buys
    save.y.pos = current.y.pos; //saved for next block

    DrawRowData(pfx, sUSDCHF, USDCHF, USDCHF.DAY, USDCHF.MAD, text.lime);
    DrawRowData(pfx, sEURGBP, EURGBP, EURGBP.DAY, EURGBP.MAD, text.lime);
    DrawRowData(pfx, sNZDUSD, NZDUSD, NZDUSD.DAY, NZDUSD.MAD, text.lime);
    DrawRowData(pfx, sGBPUSD, GBPUSD, GBPUSD.DAY, GBPUSD.MAD, text.lime);
    DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime);
    DrawRowData(pfx, sAUDJPY, AUDJPY, AUDJPY.DAY, AUDJPY.MAD, text.lime);
    DrawRowData(pfx, sGBPJPY, GBPJPY, GBPJPY.DAY, GBPJPY.MAD, text.lime);

    DrawTotal(pfx, "Week  ", AVERAGES);
    DrawTotal(pfx+"d", "Day   ", AVERAGES.DAY);
    
  //BLOCK EIGHT
    current.y.pos += (row.y.inc*3);
    current.x.pos = start.x.pos;

    pfx = "eight.";
        
    DrawHeader(pfx, "EIGHT        W D  ma");
    
    //these are changed from the original 8 longs/shorts 
    //so that all JPY are long & USD are the shorts
    
    //sells
    DrawRowData(pfx, sAUDUSD, AUDUSD, AUDUSD.DAY, AUDUSD.MAD, text.red, true);
    DrawRowData(pfx, sEURUSD, EURUSD, EURUSD.DAY, EURUSD.MAD, text.red, true);
    DrawRowData(pfx, sGBPUSD, GBPUSD_SELL, GBPUSD_SELL.DAY, GBPUSD.MAD, text.red, true);
    DrawRowData(pfx, sNZDUSD, NZDUSD_SELL, NZDUSD_SELL.DAY, NZDUSD.MAD, text.red, true);

    //buys
    DrawRowData(pfx, sAUDJPY, AUDJPY, AUDJPY.DAY, AUDJPY.MAD, text.lime);
    DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime);
    DrawRowData(pfx, sGBPJPY, GBPJPY, GBPJPY.DAY, GBPJPY.MAD, text.lime);
    DrawRowData(pfx, sNZDJPY, NZDJPY_BUY, NZDJPY_BUY.DAY, NZDJPY.MAD, text.lime);
    
//    current.y.pos += row.y.inc; //blank line between sells & buys
//    save.y.pos = current.y.pos; //saved for next block

    DrawTotal(pfx, "Week  ", EIGHT);
    DrawTotal(pfx+"d", "Day   ", EIGHT.DAY);

  // BLOCK CORE PAIRS
      
    current.y.pos = start.y.pos;
    current.x.pos = start.x.pos + col.x.inc;
    save.x.pos = current.x.pos;

    pfx = "core.";
    
    DrawHeader(pfx, "CORE PAIRS   W D  ma");        

    DrawRowData(pfx, sAUDUSD, AUDUSD, AUDUSD.DAY, AUDUSD.MAD, text.red, true);
    DrawRowData(pfx, sNZDJPY, NZDJPY, NZDJPY.DAY, NZDJPY.MAD, text.red, true, 2);
    DrawRowData(pfx, sEURUSD, EURUSD, EURUSD.DAY, EURUSD.MAD, text.red, true, 2);
    DrawRowData(pfx, sCHFJPY, CHFJPY, CHFJPY.DAY, CHFJPY.MAD, text.red, true);
    DrawRowData(pfx, sUSDJPY, USDJPY, USDJPY.DAY, USDJPY.MAD, text.red, true, 9);
            
    DrawTotal(pfx, "Week  ", CORE);
    DrawTotal(pfx+"d", "Day   ", CORE.DAY); 

  // END BLOCK CORE PAIRS

  //SIX PAIRS
    if ( Compact.Mode )
    {
      current.y.pos = save.y.pos + row.y.inc;
      current.x.pos = save.x.pos;
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  
    
    pfx = "six.";
    
    DrawHeader(pfx, "SIX PAIRS    W D  ma", 4);

    DrawRowData(pfx, sEURUSD, EURUSD, EURUSD.DAY, EURUSD.MAD, text.red, true, 3);
    DrawRowData(pfx, sUSDJPY, USDJPY, USDJPY.DAY, USDJPY.MAD, text.red, true, 3);
	  DrawRowData(pfx, sEURGBP, EURGBP, EURGBP.DAY, EURGBP.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sGBPUSD, GBPUSD, GBPUSD.DAY, GBPUSD.MAD, text.lime);
	  DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sGBPJPY, GBPJPY, GBPJPY.DAY, GBPJPY.MAD, text.lime);
            
    DrawTotal(pfx, "Week  ", THESIX);
    DrawTotal(pfx+"d", "Day   ", THESIX.DAY);
    
  //END BLOCK SIX PAIRS
  
  //BLOCK AMIGOS
    if ( Compact.Mode )
    {
      current.x.pos = save.x.pos;//start.x.pos + ( col.x.inc * 2 );
      current.y.pos += ( row.y.inc  * 2);
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }
      
    pfx = "amigo.";
    
    DrawHeader(pfx, "AMIGOS       W D  ma", 3);

	  DrawRowData(pfx, sGBPCHF, GBPCHF, GBPCHF.DAY, GBPCHF.MAD, text.red, true, 3);
	  DrawRowData(pfx, sCHFJPY, CHFJPY, CHFJPY.DAY, CHFJPY.MAD, text.red, true, 7);
	  DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime, false, 3);
            
    DrawTotal(pfx, "Week  ", AMIGOS);
    DrawTotal(pfx+"d", "Day   ", AMIGOS.DAY);
    
  //END BLOCK AMIGOS

  // BLOCK THREE PAIRS 1
      
    if ( Compact.Mode )
    {
      current.y.pos = start.y.pos;
      current.x.pos = start.x.pos + ( col.x.inc  * 2 );
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  
    save.x.pos = current.x.pos;

    pfx = "three1.";
    
    DrawHeader(pfx, "THREE 1      W D  ma", 4);        

    DrawRowData(pfx, sEURUSD, EURUSD, EURUSD.DAY, EURUSD.MAD, text.red, true, 6);    
	  DrawRowData(pfx, sEURGBP, EURGBP, EURGBP.DAY, EURGBP.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sGBPUSD, GBPUSD, GBPUSD.DAY, GBPUSD.MAD, text.lime, false, 4);
            
    DrawTotal(pfx, "Week  ", THREE1);
    DrawTotal(pfx+"d", "Day   ", THREE1.DAY);
    
  // END BLOCK THREE PAIRS 1
   
  // THREE PAIRS 2
      
    if ( Compact.Mode )
    {
      current.x.pos = save.x.pos;
      current.y.pos += ( row.y.inc * 4 );
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  

    pfx = "three2.";
    
    DrawHeader(pfx, "THREE 2      W D  ma", 3);        

	  DrawRowData(pfx, sGBPCHF, GBPCHF, GBPCHF.DAY, GBPCHF.MAD, text.red, true, 6);
	  DrawRowData(pfx, sUSDCHF, USDCHF, USDCHF.DAY, USDCHF.MAD, text.lime, false, 3);
	  DrawRowData(pfx, sGBPUSD, GBPUSD, GBPUSD.DAY, GBPUSD.MAD, text.lime, false, 4);
            
    DrawTotal(pfx, "Week  ", THREE2);
    DrawTotal(pfx+"d", "Day   ", THREE2.DAY);
    
  // END BLOCK THREE PAIRS 2
    
  // THREE PAIRS 3
      
    if ( Compact.Mode )
    {
      current.x.pos = save.x.pos;
      current.y.pos += ( row.y.inc * 5 );
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  

    pfx = "three3.";
    
    DrawHeader(pfx, "THREE 3      W D  ma", 10);        

	  DrawRowData(pfx, sEURGBP, EURGBP, EURGBP.DAY, EURGBP.MAD, text.lime, false, 3);
	  DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sGBPJPY, GBPJPY, GBPJPY.DAY, GBPJPY.MAD, text.lime);
            
    DrawTotal(pfx, "Week  ", THREE3);
    DrawTotal(pfx+"d", "Day   ", THREE3.DAY);
    
  // END BLOCK THREE PAIRS 3
      // THREE PAIRS 4
     if ( Compact.Mode )
    {
      current.y.pos = start.y.pos;
      current.x.pos = start.x.pos + ( col.x.inc  * 3 );
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  
    save.x.pos = current.x.pos;

    pfx = "three4.";
    DrawHeader(pfx, "THREE 4      W D  ma", 10);        
	  DrawRowData(pfx, sUSDJPY, USDJPY, USDJPY.DAY, USDJPY.MAD, text.red, true, 3);
	  DrawRowData(pfx, sEURJPY, EURJPY, EURJPY.DAY, EURJPY.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sGBPJPY, GBPJPY, GBPJPY.DAY, GBPJPY.MAD, text.lime);
    DrawTotal(pfx, "Week  ", THREE4);
    DrawTotal(pfx+"d", "Day   ", THREE4.DAY);
  // END BLOCK THREE PAIRS 4
    // THREE PAIRS 5
    if ( Compact.Mode )
    {
      current.x.pos = save.x.pos;
      current.y.pos += ( row.y.inc * 4 );
    }
    else
    {
      current.y.pos = start.y.pos;
      current.x.pos += col.x.inc;
    }  
    pfx = "three5.";
    DrawHeader(pfx, "THREE 5      W D  ma", 3);        
	  DrawRowData(pfx, sUSDCHF, USDCHF, USDCHF.DAY, USDCHF.MAD, text.lime, false, 2);
	  DrawRowData(pfx, sEURCHF, EURCHF, EURCHF.DAY, EURCHF.MAD, text.red, true, 3);
	  DrawRowData(pfx, sGBPCHF, GBPCHF, GBPCHF.DAY, GBPCHF.MAD, text.red, true, 4);
    DrawTotal(pfx, "Week  ", THREE5);
    DrawTotal(pfx+"d", "Day   ", THREE5.DAY);
  // END BLOCK THREE PAIRS 5
  // SWAPS
    if ( Show.Swap.Values )
    {
      current.y.pos = start.y.pos;
      if (Compact.Mode) current.x.pos = start.x.pos + col.x.inc*4;
      else current.x.pos = start.x.pos + col.x.inc*7;
      save.x.pos = current.x.pos;
      pfx = "swaps.";
      DrawHeader(pfx, "SWAPS    LONG  SHORT");        
      DrawSwapData(pfx, sAUDUSD, text.red);
      DrawSwapData(pfx, sNZDJPY, text.red);
      DrawSwapData(pfx, sGBPCHF, text.red);
      DrawSwapData(pfx, sEURUSD, text.red);
      DrawSwapData(pfx, sEURCHF, text.red);
      DrawSwapData(pfx, sCHFJPY, text.red);
      DrawSwapData(pfx, sUSDJPY, text.red);
      
 	    current.y.pos += row.y.inc; //blank line between sells & buys
	    save.y.pos = current.y.pos; //saved for next block
	    
      DrawSwapData(pfx, sUSDCHF, text.lime);
      DrawSwapData(pfx, sEURGBP, text.lime);
      DrawSwapData(pfx, sNZDUSD, text.lime);
      DrawSwapData(pfx, sGBPUSD, text.lime);
      DrawSwapData(pfx, sEURJPY, text.lime);
      DrawSwapData(pfx, sAUDJPY, text.lime);
      DrawSwapData(pfx, sGBPJPY, text.lime);
    }  
  // END SWAPS

   //ALERTS - need to refactor this code

  if ( NormalizeDouble(EIGHT,0)==0 )
  {
     if ( Enable.Alerts && TimeCurrent() > no.alerts.before.eight )
     {
       no.alerts.before.eight = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
       Alert("EIGHT OPEN BASKET");
     }  
     Print("EIGHT bid / ask prices are: Core EURJPY ASK (",EURJPY.ASK,") & EIGHT EURJPY BID (",EURJPY.BID,")");
     Print("EIGHT bid / ask prices are: Core NZDJPY ASK (",NZDJPY.ASK,") & EIGHT NZDJPY BID (",NZDJPY.BID,")");
     Print("EIGHT bid / ask prices are: Core GBPUSD ASK (",GBPUSD.ASK,") & EIGHT GBPUSD BID (",GBPUSD.BID,")");
     Print("EIGHT bid / ask prices are: Core AUDUSD ASK (",AUDUSD.ASK,") & EIGHT AUDUSD BID (",AUDUSD.BID,")");
     
     Print("EIGHT bid / ask prices are: Core EURUSD ASK (",EURUSD.ASK,") & EIGHT EURUSD BID (",EURUSD.BID,")");
     Print("EIGHT bid / ask prices are: Core NZDUSD ASK (",NZDUSD.ASK,") & EIGHT NZDUSD BID (",NZDUSD.BID,")");
     Print("EIGHT bid / ask prices are: Core GBPJPY ASK (",GBPJPY.ASK,") & EIGHT GBPJPY BID (",GBPJPY.BID,")");
     Print("EIGHT bid / ask prices are: Core AUDJPY ASK (",AUDJPY.ASK,") & EIGHT AUDJPY BID (",AUDJPY.BID,")");
  }
   
  if ( NormalizeDouble(CORE,0)==0 )
  {
     if ( Enable.Alerts && TimeCurrent() > no.alerts.before.core )
     {
       no.alerts.before.core = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
       Alert("CORE OPEN BASKET"); //just in case they don't want alerts 
     }  
     Print("CORE bid / ask prices are: Core AUDUSD ASK (",AUDUSD.ASK,") & Core AUDUSD BID (",AUDUSD.BID,")");
     Print("CORE bid / ask prices are: Core NZDJPY ASK (",NZDJPY.ASK,") & Core NZDJPY BID (",NZDJPY.BID,")");
     Print("CORE bid / ask prices are: Core EURUSD ASK (",EURUSD.ASK,") & Core EURUSD BID (",EURUSD.BID,")");
     Print("CORE bid / ask prices are: Core CHFJPY ASK (",CHFJPY.ASK,") & Core CHFJPY BID (",CHFJPY.BID,")");
     Print("CORE bid / ask prices are: Core USDJPY ASK (",USDJPY.ASK,") & Core USDJPY BID (",USDJPY.BID,")");
  }

  if (NormalizeDouble(AMIGOS,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.amigos )
    {
      no.alerts.before.amigos = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("AMIGOS OPEN BASKET");
    }  
    Print("AMIGOS bid / ask prices are: AMIGOS GBPCHF ASK (",MarketInfo(sGBPCHF,MODE_ASK),") & AMIGOS GBPCHF BID (",MarketInfo(sGBPCHF,MODE_BID),")");
    Print("AMIGOS bid / ask prices are: AMIGOS CHFJPY ASK (",MarketInfo(sCHFJPY,MODE_ASK),") & AMIGOS CHFJPY BID (",MarketInfo(sCHFJPY,MODE_BID),")");
    Print("AMIGOS bid / ask prices are: AMIGOS EURJPY ASK (",MarketInfo(sEURJPY,MODE_ASK),") & AMIGOS EURUSD BID (",MarketInfo(sEURJPY,MODE_BID),")");
  }
  
  if (NormalizeDouble(THREE1,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.three1 )
    {
      no.alerts.before.three1 = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THREE1 OPEN BASKET");
    }  
    Print("THREE1 bid / ask prices are: THREE1 EURUSD ASK (",MarketInfo(sEURUSD,MODE_ASK),") & THREE1 EURUSD BID (",MarketInfo(sEURUSD,MODE_BID),")");
    Print("THREE1 bid / ask prices are: THREE1 GBPUSD ASK (",MarketInfo(sGBPUSD,MODE_ASK),") & THREE1 GBPUSD BID (",MarketInfo(sGBPUSD,MODE_BID),")");
    Print("THREE1 bid / ask prices are: THREE1 EURGBP ASK (",MarketInfo(sEURGBP,MODE_ASK),") & THREE1 EURGBP BID (",MarketInfo(sEURGBP,MODE_BID),")");
  }
      
      
  if (NormalizeDouble(THREE2,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.three2 )
    {
      no.alerts.before.three2 = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THREE2 OPEN BASKET");
    }  
    Print("THREE2 bid / ask prices are: THREE2 GBPCHF ASK (",MarketInfo(sGBPCHF,MODE_ASK),") & THREE2 GBPCHF BID (",MarketInfo(sGBPCHF,MODE_BID),")");
    Print("THREE2 bid / ask prices are: THREE2 USDCHF ASK (",MarketInfo(sUSDCHF,MODE_ASK),") & THREE2 USDCHF BID (",MarketInfo(sUSDCHF,MODE_BID),")");
    Print("THREE2 bid / ask prices are: THREE2 GBPUSD ASK (",MarketInfo(sGBPUSD,MODE_ASK),") & THREE2 GBPUSD BID (",MarketInfo(sGBPUSD,MODE_BID),")");
  }
      
  if (NormalizeDouble(THREE3,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.three3 )
    {
      no.alerts.before.three3 = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THREE3 OPEN BASKET");
    }  
    Print("THREE3 bid / ask prices are: THREE3 EURGBP ASK (",MarketInfo(sEURGBP,MODE_ASK),") & THREE3 EURGBP BID (",MarketInfo(sEURGBP,MODE_BID),")");
    Print("THREE3 bid / ask prices are: THREE3 EURJPY ASK (",MarketInfo(sEURJPY,MODE_ASK),") & THREE3 EURJPY BID (",MarketInfo(sEURJPY,MODE_BID),")");
    Print("THREE3 bid / ask prices are: THREE3 GBPJPY ASK (",MarketInfo(sGBPJPY,MODE_ASK),") & THREE3 GBPJPY BID (",MarketInfo(sGBPJPY,MODE_BID),")");
  }
   if (NormalizeDouble(THREE4,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.three4 )
    {
      no.alerts.before.three4 = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THREE4 OPEN BASKET");
    }  
    Print("THREE4 bid / ask prices are: THREE4 USDJPY ASK (",MarketInfo(sUSDJPY,MODE_ASK),") & THREE4 USDJPY BID (",MarketInfo(sUSDJPY,MODE_BID),")");
    Print("THREE4 bid / ask prices are: THREE4 EURJPY ASK (",MarketInfo(sEURJPY,MODE_ASK),") & THREE4 EURJPY BID (",MarketInfo(sEURJPY,MODE_BID),")");
    Print("THREE4 bid / ask prices are: THREE4 GBPJPY ASK (",MarketInfo(sGBPJPY,MODE_ASK),") & THREE4 GBPJPY BID (",MarketInfo(sGBPJPY,MODE_BID),")");
  }
        
  if (NormalizeDouble(THREE5,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.three5 )
    {
      no.alerts.before.three5 = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THREE5 OPEN BASKET");
    }  
    Print("THREE5 bid / ask prices are: THREE5 USDCHF ASK (",MarketInfo(sUSDCHF,MODE_ASK),") & THREE5 USDCHF BID (",MarketInfo(sUSDCHF,MODE_BID),")");
    Print("THREE5 bid / ask prices are: THREE5 EURCHF ASK (",MarketInfo(sEURCHF,MODE_ASK),") & THREE5 EURCHF BID (",MarketInfo(sEURCHF,MODE_BID),")");
    Print("THREE5 bid / ask prices are: THREE5 GBPCHF ASK (",MarketInfo(sGBPCHF,MODE_ASK),") & THREE5 GBPCHF BID (",MarketInfo(sGBPCHF,MODE_BID),")");
  }
  if (NormalizeDouble(THESIX,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.six )
    {
      no.alerts.before.six = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("THESIX OPEN BASKET");
    }  
    Print("THESIX bid / ask prices are: THESIX GBPUSD ASK (",MarketInfo(sGBPUSD,MODE_ASK),") & THESIX GBPUSD BID (",MarketInfo(sGBPUSD,MODE_BID),")");
    Print("THESIX bid / ask prices are: THESIX EURUSD ASK (",MarketInfo(sEURUSD,MODE_ASK),") & THESIX EURUSD BID (",MarketInfo(sEURUSD,MODE_BID),")");
    Print("THESIX bid / ask prices are: THESIX EURGBP ASK (",MarketInfo(sEURGBP,MODE_ASK),") & THESIX EURGBP BID (",MarketInfo(sEURGBP,MODE_BID),")");
    Print("THESIX bid / ask prices are: THESIX USDJPY ASK (",MarketInfo(sUSDJPY,MODE_ASK),") & THESIX USDJPY BID (",MarketInfo(sUSDJPY,MODE_BID),")");
    Print("THESIX bid / ask prices are: THESIX EURJPY ASK (",MarketInfo(sEURJPY,MODE_ASK),") & THESIX EURJPY BID (",MarketInfo(sEURJPY,MODE_BID),")");
    Print("THESIX bid / ask prices are: THESIX GBPJPY ASK (",MarketInfo(sGBPJPY,MODE_ASK),") & THESIX GBPJPY BID (",MarketInfo(sGBPJPY,MODE_BID),")");
  }
  
      
  if (NormalizeDouble(AVERAGES,0)==0)
  {
    if ( Enable.Alerts && TimeCurrent() > no.alerts.before.averages )
    {
      no.alerts.before.averages = TimeCurrent() + alert.period.reset.secs; //30 minutes = 1800 seconds
      Alert("AVERAGES OPEN BASKET");
    }  
    Print("AVERAGES bid / ask prices are: AVERAGES AUDUSD ASK (",MarketInfo(sAUDUSD,MODE_ASK),") & AVERAGES AUDUSD BID (",MarketInfo(sAUDUSD,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES NZDJPY ASK (",MarketInfo(sNZDJPY,MODE_ASK),") & AVERAGES NZDJPY BID (",MarketInfo(sNZDJPY,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES GBPCHF ASK (",MarketInfo(sGBPCHF,MODE_ASK),") & AVERAGES GBPCHF BID (",MarketInfo(sGBPCHF,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES EURUSD ASK (",MarketInfo(sEURUSD,MODE_ASK),") & AVERAGES EURUSD BID (",MarketInfo(sEURUSD,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES EURCHF ASK (",MarketInfo(sEURCHF,MODE_ASK),") & AVERAGES EURCHF BID (",MarketInfo(sEURCHF,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES CHFJPY ASK (",MarketInfo(sCHFJPY,MODE_ASK),") & AVERAGES CHFJPY BID (",MarketInfo(sCHFJPY,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES USDJPY ASK (",MarketInfo(sUSDJPY,MODE_ASK),") & AVERAGES USDJPY BID (",MarketInfo(sUSDJPY,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES USDCHF ASK (",MarketInfo(sUSDCHF,MODE_ASK),") & AVERAGES USDCHF BID (",MarketInfo(sUSDCHF,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES EURGBP ASK (",MarketInfo(sEURGBP,MODE_ASK),") & AVERAGES EURGBP BID (",MarketInfo(sEURGBP,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES NZDUSD ASK (",MarketInfo(sNZDUSD,MODE_ASK),") & AVERAGES NZDUSD BID (",MarketInfo(sNZDUSD,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES GBPUSD ASK (",MarketInfo(sGBPUSD,MODE_ASK),") & AVERAGES GBPUSD BID (",MarketInfo(sGBPUSD,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES EURJPY ASK (",MarketInfo(sEURJPY,MODE_ASK),") & AVERAGES EURJPY BID (",MarketInfo(sEURJPY,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES AUDJPY ASK (",MarketInfo(sAUDJPY,MODE_ASK),") & AVERAGES AUDJPY BID (",MarketInfo(sAUDJPY,MODE_BID),")");
    Print("AVERAGES bid / ask prices are: AVERAGES GBPJPY ASK (",MarketInfo(sGBPJPY,MODE_ASK),") & AVERAGES GBPJPY BID (",MarketInfo(sGBPJPY,MODE_BID),")");
  }
   

  
  return(0);
}  


