//+------------------------------------------------------------------+
//|                                                       sixths.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window

int BarCount = 0;
int CurBars;
extern string CCIHelp = "--Hourly Period for CCI MA--";
extern int CCIPeriod=120;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      ObjectCreate("topline",1,0,TimeCurrent(),High[120]);
      ObjectSet("topline",OBJPROP_COLOR,Magenta);
      ObjectSet("topline",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("topline",OBJPROP_WIDTH,2);     
  
      ObjectCreate("halfbottomline",1,0,TimeCurrent(),Low[120]);
      ObjectSet("halfbottomline",OBJPROP_COLOR,Magenta);
      ObjectSet("halfbottomline",OBJPROP_STYLE,STYLE_DASH);
      ObjectSet("halfbottomline",OBJPROP_WIDTH,1);     
  
      ObjectCreate("halftopline",1,0,TimeCurrent(),High[120]);
      ObjectSet("halftopline",OBJPROP_COLOR,Magenta);
      ObjectSet("halftopline",OBJPROP_STYLE,STYLE_DASH);
      ObjectSet("halftopline",OBJPROP_WIDTH,1);     
  
      ObjectCreate("bottomline",1,0,TimeCurrent(),Low[120]);
      ObjectSet("bottomline",OBJPROP_COLOR,Magenta);
      ObjectSet("bottomline",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("bottomline",OBJPROP_WIDTH,2);     
  
      ObjectCreate("onesixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("onesixth",OBJPROP_COLOR,Gold);
      ObjectSet("onesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("onesixth",OBJPROP_WIDTH,2);     
  
      ObjectCreate("twosixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("twosixth",OBJPROP_COLOR,Green);
      ObjectSet("twosixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("twosixth",OBJPROP_WIDTH,2);    

      ObjectCreate("threesixth",1,0,TimeCurrent(),High[120]);
      ObjectSet("threesixth",OBJPROP_COLOR,White);
      ObjectSet("threesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("threesixth",OBJPROP_WIDTH,2);
      
      ObjectCreate("foursixth",1,0,TimeCurrent(),Low[120]);
      ObjectSet("foursixth",OBJPROP_COLOR,Green);
      ObjectSet("foursixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("foursixth",OBJPROP_WIDTH,2);
      
      ObjectCreate("fivesixth",1,0,TimeCurrent(),Low[120]);
      ObjectSet("fivesixth",OBJPROP_COLOR,Gold);
      ObjectSet("fivesixth",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("fivesixth",OBJPROP_WIDTH,2);
      
   if (BarCount == 0)
   {
      GetBarCount();
      
    }//if (BarCount == 0)
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("topline");
   ObjectDelete("halftopline");
   ObjectDelete("halfbottomline");
   ObjectDelete("bottomline");
   ObjectDelete("onesixth");
   ObjectDelete("twosixth");
   ObjectDelete("threesixth");
   ObjectDelete("foursixth");
   ObjectDelete("fivesixth");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   
//----
//----
   if(CurBars!=iBars(NULL,PERIOD_H1)) GetBarCount();
   
   double TopLine = High[iHighest(NULL,0,MODE_HIGH,BarCount,1)];
   if (High[0] > TopLine) TopLine = NormalizeDouble(High[0], Digits);
   double BottomLine = Low[iLowest(NULL,0,MODE_LOW,BarCount,1)];
   if (Low[0] < BottomLine) BottomLine = NormalizeDouble(Low[0], Digits);
   
   //double value = High[iHighest(NULL,0,MODE_HIGH,BarCount,1)] - Low[iLowest(NULL,0,MODE_LOW,BarCount,1)];      //value top of the chart - value bottom
   double value = TopLine - BottomLine;
   double sixth = value/6;
   double valueS = (value*(MathPow(10,Digits)));
   double sixthS = (sixth*(MathPow(10,Digits)));
   
   
   if(ObjectFind("fivesixth")==-1)init();
   
   /*
   ObjectMove("topline",0,TimeCurrent(),High[iHighest(NULL,0,MODE_HIGH,BarCount,1)]);
   ObjectMove("halftopline",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth+sixth+sixth+(sixth/2));
   ObjectMove("halfbottomline",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+(sixth/2));
   ObjectMove("bottomline",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]);
   ObjectMove("onesixth",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth);
   ObjectMove("twosixth",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth);
   ObjectMove("threesixth",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth);
   ObjectMove("foursixth",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth+sixth);
   ObjectMove("fivesixth",0,TimeCurrent(),Low[iLowest(NULL,0,MODE_LOW,BarCount,1)]+sixth+sixth+sixth+sixth+sixth);
   */
   ObjectMove("topline",0,TimeCurrent(),TopLine);
   ObjectMove("halftopline",0,TimeCurrent(),BottomLine+sixth+sixth+sixth+sixth+sixth+(sixth/2));
   ObjectMove("halfbottomline",0,TimeCurrent(),BottomLine+(sixth/2));
   ObjectMove("bottomline",0,TimeCurrent(),BottomLine);
   ObjectMove("onesixth",0,TimeCurrent(),BottomLine+sixth);
   ObjectMove("twosixth",0,TimeCurrent(),BottomLine+sixth+sixth);
   ObjectMove("threesixth",0,TimeCurrent(),BottomLine+sixth+sixth+sixth);
   ObjectMove("foursixth",0,TimeCurrent(),BottomLine+sixth+sixth+sixth+sixth);
   ObjectMove("fivesixth",0,TimeCurrent(),BottomLine+sixth+sixth+sixth+sixth+sixth);
      
//----
   return(0);
  }
//+------------------------------------------------------------------+

int GetBarCount()
  {
   int IndTimeframe=PERIOD_H1;
   int PeriodCount=0;
   int PeriodTotal=0;
   int TempAbovePer=0;
   int TempBelowPer=0;
   int CCIPos=0;
   int TempCCIPos=0;
   
   double multiplier=1;
   if (Period() == PERIOD_M1) multiplier = 60;
   if (Period() == PERIOD_M5) multiplier = 12;
   if (Period() == PERIOD_M15) multiplier = 4;
   if (Period() == PERIOD_M30) multiplier = 2;
   if (Period() == PERIOD_H1) multiplier = 1;
   if (Period() == PERIOD_H4) multiplier = 0.25;
   if (Period() == PERIOD_D1) multiplier = 0.25 / 6;

   CurBars=iBars(NULL,IndTimeframe);
   int IndBars=MathMin(720,CurBars);
   for(int i=1;i<=IndBars;i++)
     {
       TempCCIPos=CCIPos;
      if(iCCI(NULL,IndTimeframe,CCIPeriod,PRICE_WEIGHTED,i)>100 && CCIPos != 1)
        {
         TempAbovePer=i;
         CCIPos=1;
        }
      if(iCCI(NULL,IndTimeframe,CCIPeriod,PRICE_WEIGHTED,i)<-100 && CCIPos != -1)
        {
         TempBelowPer=i;
         CCIPos=-1;
        }
      if(TempAbovePer>0 && TempBelowPer>0 && CCIPos != TempCCIPos && CCIPos!=0)
        {
         PeriodCount++;
         PeriodTotal+=MathAbs(TempAbovePer-TempBelowPer);
        }
     }
   
   if(PeriodCount==0) BarCount=170*multiplier;
   else BarCount=PeriodTotal/PeriodCount*multiplier;
   Print("Tot Bars: ", PeriodTotal, " / Total Reversals: ", PeriodCount, " * TimeframeMultiplier: ", multiplier, " = ", BarCount);
   }