#property copyright ""
#property link      ""
#property show_inputs

extern double Lots        = 0.01;
extern string nb1 = "set expiry.hours = 0 for no expiry ";
extern int expiry.hours = 144;
extern string nb2 = "set Use.ADR.Values = false for bosuns";
extern bool Use.ADR.Values = true;

int StartDay  = 1;     // 0=Sunday, 1=Monday

//extern bool Buy.Stop = true;
//extern bool Sell.Stop = true;
//extern int    StopLoss    = 0;
//extern int    TakeProfit  = 0;
//extern int    DistanceSet = 100;

int    Slippage    = 5;


string Name_Expert   = "Set2StopOrders";
bool   UseSound      = false;
string NameFileSound = "expert.wav";
color  clOpenBuy     = LightBlue;
color  clOpenSell    = LightCoral;

double last_week_high, last_week_low, last_week_close, this_week_open;

double WH,WL,WC,PP,PD,PRH,PRL;
double S1,R1,S2,R2,S3,R3;

#define RETRYCOUNT    10
#define RETRYDELAY    100

double GetADRValue()
{

  int First_av = 5;
  int Second_av = 8;
  int Third_av = 13;

   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=First_av;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Second_av;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=Third_av;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

   R5 = R5/First_av;
   R10 = R10/Second_av;
   R20 = R20/Third_av;
   RAvg  =  (R1+R5+R10+R20)/4;
   
   return(RAvg);
}


void GetLevels()
{
  int limit, i;

  double ADR = GetADRValue();
  
  double ADR2 = ADR / 1000;
  double ADR1 = ADR2 / 2.29;//2.19;
  double ADR3 = ADR2 * 1.61;
  
  bool done = false;
       
  for(i=0; i<=(8*1440);i++)
  {
    if ( StartDay==TimeDayOfWeek(Time[i]) && StartDay!=TimeDayOfWeek(Time[i+1]) )  
    {
      last_week_close=Close[i+1];
      this_week_open=Open[i];

      WH = last_week_high;
      WL = last_week_low;
      WC = last_week_close;
      
      if ( Use.ADR.Values )
      {   
        R3 = WC + ( ADR * ADR3 * Point );
        R2 = WC + ( ADR * ADR2 * Point );         
        R1 = WC + ( ADR * ADR1 * Point );
        PP = WC;
        S1 = WC - ( ADR * ADR1 * Point );
        S2 = WC - ( ADR * ADR2 * Point );
        S3 = WC - ( ADR * ADR3 * Point );
      }
      else
      {
        R3 = WC * 1.0625;
        R2 = WC * 1.0312;         
        R1 = WC * 1.0156;
        PP = WC;
        S1 = WC * 0.9844;
        S2 = WC * 0.9688;
        S3 = WC * 0.9375;      
      }  
			
      last_week_low  = Low[i];
      last_week_high = High[i];
      
      done = true;
    }
    if (done) break;      
	}
	return(0); 
}

void start() 
{

  GetLevels();  

//  Comment(R3," ",R2," ", R1," ",PP," ",S1," ",S2," ",S3);
//  return(0);

  string c = "adr.";
  if ( ! Use.ADR.Values ) c = "bsn.";
  
  if ( Ask < R2 ) SetOrder(OP_SELLLIMIT, R3, 0, R2, c+"R3");
  if ( Ask < R1 ) SetOrder(OP_SELLLIMIT, R2, 0, R1, c+"R2");
  if ( Ask < PP ) SetOrder(OP_SELLLIMIT, R1, 0, PP, c+"R1");  
  
  if ( Bid > PP ) SetOrder(OP_BUYLIMIT, S1, 0, PP, c+"S1");
  if ( Bid > S1 ) SetOrder(OP_BUYLIMIT, S2, 0, S1, c+"S2");
  if ( Bid > S2 ) SetOrder(OP_BUYLIMIT, S3, 0, S2, c+"S3");

}


void SetOrder(int op, double pp, double ldStop, double ldTake, string cmt) 
{
  int ticket;
  
  datetime expiry = 0;
  
  for (int i=0; i<RETRYCOUNT; i++) 
  {
    for (int j=0; j<50 && IsTradeContextBusy(); j++) Sleep(RETRYDELAY);
    
    RefreshRates();
  
    ticket = OrderSend(Symbol(),op,Lots,NormalizeDouble(pp, Digits),Slippage,0,0,cmt,0,0);
    
    if ( ticket > 0 && ldTake > 0 )
    {
      if ( OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES) )
      {
        if ( expiry.hours > 0 ) expiry = OrderOpenTime() + ( expiry.hours * 60 * 60 );

        //if ( OrderModify(ticket, OrderOpenPrice(), 0, NormalizeDouble(ldTake,Digits), OrderExpiration()) ) 
        if ( OrderModify(ticket, OrderOpenPrice(), 0, NormalizeDouble(ldTake,Digits), expiry) ) 
        {
          Print("Trade added: ", ticket);
          break;
        }
      }    
    }
    
    if ( ticket > 0 ) break;
  }    
}

